Ruby 2.7.0p0(2019-12-25revision647ee6f091eafcce70ffb75ddf7e121e192ab217)

Data Structures | Macros | Typedefs | Functions | Variables
intern.h File Reference
`#include "ruby/defines.h"`
`#include <varargs.h>`
`#include "ruby/st.h"`

Go to the source code of this file.

## Data Structures
struct | rb_arithmetic_sequence_components_t

## Macros
#define | __has_attribute(x) 0
#define | MJIT_STATIC
#define | UNLIMITED_ARGUMENTS (-1)
#define | rb_ary_new2 rb_ary_new_capa
#define | rb_ary_new3 rb_ary_new_from_args
#define | rb_ary_new4 rb_ary_new_from_values
#define | rb_big2int(x) rb_big2long(x)
#define | rb_big2uint(x) rb_big2ulong(x)
#define | INTEGER_PACK_MSWORD_FIRST 0x01
#define | INTEGER_PACK_LSWORD_FIRST 0x02
#define | INTEGER_PACK_MSBYTE_FIRST 0x10
#define | INTEGER_PACK_LSBYTE_FIRST 0x20
#define | INTEGER_PACK_NATIVE_BYTE_ORDER 0x40
#define | INTEGER_PACK_2COMP 0x80
#define | INTEGER_PACK_FORCE_GENERIC_IMPLEMENTATION 0x400
#define | INTEGER_PACK_FORCE_BIGNUM 0x100
#define | INTEGER_PACK_NEGATIVE 0x200
#define | INTEGER_PACK_LITTLE_ENDIAN
#define | INTEGER_PACK_BIG_ENDIAN
#define | rb_rational_raw1(x) rb_rational_raw((x), INT2FIX(1))
#define | rb_rational_raw2(x, y) rb_rational_raw((x), (y))
#define | rb_rational_new1(x) rb_rational_new((x), INT2FIX(1))
#define | rb_rational_new2(x, y) rb_rational_new((x), (y))
#define | rb_Rational1(x) rb_Rational((x), INT2FIX(1))
#define | rb_Rational2(x, y) rb_Rational((x), (y))
#define | rb_complex_raw1(x) rb_complex_raw((x), INT2FIX(0))
#define | rb_complex_raw2(x, y) rb_complex_raw((x), (y))
#define | rb_complex_new1(x) rb_complex_new((x), INT2FIX(0))
#define | rb_complex_new2(x, y) rb_complex_new((x), (y))
#define | rb_complex_add rb_complex_plus
#define | rb_complex_sub rb_complex_minus
#define | rb_complex_nagate rb_complex_uminus
#define | rb_Complex1(x) rb_Complex((x), INT2FIX(0))
#define | rb_Complex2(x, y) rb_Complex((x), (y))
#define | rb_enumeratorize_with_size(obj, id, argc, argv, size_fn) rb_enumeratorize_with_size(obj, id, argc, argv, (rb_enumerator_size_func *)(size_fn))
#define | rb_enumeratorize_with_size_kw(obj, id, argc, argv, size_fn, kw_splat) rb_enumeratorize_with_size_kw(obj, id, argc, argv, (rb_enumerator_size_func *)(size_fn), kw_splat)
#define | SIZED_ENUMERATOR(obj, argc, argv, size_fn)
#define | SIZED_ENUMERATOR_KW(obj, argc, argv, size_fn, kw_splat)
#define | RETURN_SIZED_ENUMERATOR(obj, argc, argv, size_fn)
#define | RETURN_SIZED_ENUMERATOR_KW(obj, argc, argv, size_fn, kw_splat)
#define | RETURN_ENUMERATOR(obj, argc, argv) RETURN_SIZED_ENUMERATOR(obj, argc, argv, 0)
#define | RETURN_ENUMERATOR_KW(obj, argc, argv, kw_splat) RETURN_SIZED_ENUMERATOR_KW(obj, argc, argv, 0, kw_splat)
#define | rb_exc_new2 rb_exc_new_cstr
#define | rb_exc_new3 rb_exc_new_str
#define | rb_check_frozen_internal(obj)
#define | rb_check_frozen(obj) rb_check_frozen_inline(obj)
#define | rb_check_trusted(obj) rb_check_trusted_inline(obj)
#define | RB_OBJ_INIT_COPY(obj, orig) ((obj) != (orig) && (rb_obj_init_copy((obj), (orig)), 1))
#define | OBJ_INIT_COPY(obj, orig) RB_OBJ_INIT_COPY(obj, orig)
#define | rb_check_arity rb_check_arity /* for ifdef */
#define | rb_fd_zero(f) FD_ZERO(f)
#define | rb_fd_set(n, f) FD_SET((n), (f))
#define | rb_fd_clr(n, f) FD_CLR((n), (f))
#define | rb_fd_isset(n, f) FD_ISSET((n), (f))
#define | rb_fd_copy(d, s, n) (*(d) = *(s))
#define | rb_fd_dup(d, s) (*(d) = *(s))
#define | rb_fd_resize(n, f) ((void)(f))
#define | rb_fd_ptr(f) (f)
#define | rb_fd_init(f) FD_ZERO(f)
#define | rb_fd_init_copy(d, s) (*(d) = *(s))
#define | rb_fd_term(f) ((void)(f))
#define | rb_fd_max(f) FD_SETSIZE
#define | rb_fd_select(n, rfds, wfds, efds, timeout) select((n), (rfds), (wfds), (efds), (timeout))
#define | HAVE_RB_DEFINE_ALLOC_FUNC 1
#define | st_foreach_safe rb_st_foreach_safe
#define | rb_defout rb_stdout
#define | RB_RESERVED_FD_P(fd) rb_reserved_fd_p(fd)
#define | RB_NUM_COERCE_FUNCS_NEED_OPID 1
#define | rb_memcmp memcmp
#define | HAVE_RB_REG_NEW_STR 1
#define | rb_argv rb_get_argv()
#define | rb_str_dup_frozen rb_str_new_frozen
#define | rb_hash_uint32(h, i) st_hash_uint32((h), (i))
#define | rb_hash_uint(h, i) st_hash_uint((h), (i))
#define | rb_hash_end(h) st_hash_end(h)
#define | rb_str_new2 rb_str_new_cstr
#define | rb_str_new3 rb_str_new_shared
#define | rb_str_new4 rb_str_new_frozen
#define | rb_str_new5 rb_str_new_with_class
#define | rb_tainted_str_new2 rb_tainted_str_new_cstr
#define | rb_str_buf_new2 rb_str_buf_new_cstr
#define | rb_usascii_str_new2 rb_usascii_str_new_cstr
#define | rb_str_buf_cat rb_str_cat
#define | rb_str_buf_cat2 rb_str_cat_cstr
#define | rb_str_cat2 rb_str_cat_cstr
#define | rb_strlen_lit(str) (sizeof(str "") - 1)
#define | rb_str_new_lit(str) rb_str_new_static((str), rb_strlen_lit(str))
#define | rb_usascii_str_new_lit(str) rb_usascii_str_new_static((str), rb_strlen_lit(str))
#define | rb_utf8_str_new_lit(str) rb_utf8_str_new_static((str), rb_strlen_lit(str))
#define | rb_enc_str_new_lit(str, enc) rb_enc_str_new_static((str), rb_strlen_lit(str), (enc))
#define | rb_str_new_literal(str) rb_str_new_lit(str)
#define | rb_usascii_str_new_literal(str) rb_usascii_str_new_lit(str)
#define | rb_utf8_str_new_literal(str) rb_utf8_str_new_lit(str)
#define | rb_enc_str_new_literal(str, enc) rb_enc_str_new_lit(str, enc)
#define | RUBY_UBF_IO ((rb_unblock_function_t *)-1)
#define | RUBY_UBF_PROCESS ((rb_unblock_function_t *)-1)
#define | rb_f_notimplement_p(f) 0

## Typedefs
typedef VALUE | rb_enumerator_size_func(VALUE, VALUE, VALUE)
typedef fd_set | rb_fdset_t
typedef VALUE(* | rb_alloc_func_t) (VALUE)
typedef VALUE | rb_hash_update_func(VALUE newkey, VALUE oldkey, VALUE value)
typedef void | rb_unblock_function_t(void *)
typedef VALUE | rb_blocking_function_t(void *)

## Functions
void | rb_mem_clear (VALUE *, long)
VALUE | rb_assoc_new (VALUE, VALUE)
VALUE | rb_check_array_type (VALUE)
VALUE | rb_ary_new (void)
VALUE | rb_ary_new_capa (long capa)
VALUE | rb_ary_new_from_args (long n,...)
VALUE | rb_ary_new_from_values (long n, const VALUE *elts)
VALUE | rb_ary_tmp_new (long)
void | rb_ary_free (VALUE)
void | rb_ary_modify (VALUE)
VALUE | rb_ary_freeze (VALUE)
VALUE | rb_ary_shared_with_p (VALUE, VALUE)
VALUE | rb_ary_aref (int, const VALUE *, VALUE)
VALUE | rb_ary_subseq (VALUE, long, long)
void | rb_ary_store (VALUE, long, VALUE)
VALUE | rb_ary_dup (VALUE)
VALUE | rb_ary_resurrect (VALUE ary)
VALUE | rb_ary_to_ary (VALUE)
VALUE | rb_ary_to_s (VALUE)
VALUE | rb_ary_cat (VALUE, const VALUE *, long)
VALUE | rb_ary_push (VALUE, VALUE)
VALUE | rb_ary_pop (VALUE)
VALUE | rb_ary_shift (VALUE)
VALUE | rb_ary_unshift (VALUE, VALUE)
VALUE | rb_ary_entry (VALUE, long)
VALUE | rb_ary_each (VALUE)
VALUE | rb_ary_join (VALUE, VALUE)
VALUE | rb_ary_reverse (VALUE)
VALUE | rb_ary_rotate (VALUE, long)
VALUE | rb_ary_sort (VALUE)
VALUE | rb_ary_sort_bang (VALUE)
VALUE | rb_ary_delete (VALUE, VALUE)
VALUE | rb_ary_delete_at (VALUE, long)
VALUE | rb_ary_clear (VALUE)
VALUE | rb_ary_plus (VALUE, VALUE)
VALUE | rb_ary_concat (VALUE, VALUE)
VALUE | rb_ary_assoc (VALUE, VALUE)
VALUE | rb_ary_rassoc (VALUE, VALUE)
VALUE | rb_ary_includes (VALUE, VALUE)
VALUE | rb_ary_cmp (VALUE, VALUE)
VALUE | rb_ary_replace (VALUE copy, VALUE orig)
VALUE | rb_get_values_at (VALUE, long, int, const VALUE *, VALUE(*)(VALUE, long))
VALUE | rb_ary_resize (VALUE ary, long len)
| expands or shrinks ary to len elements. More...
VALUE | rb_big_new (size_t, int)
int | rb_bigzero_p (VALUE x)
VALUE | rb_big_clone (VALUE)
void | rb_big_2comp (VALUE)
VALUE | rb_big_norm (VALUE)
void | rb_big_resize (VALUE big, size_t len)
VALUE | rb_cstr_to_inum (const char *, int, int)
VALUE | rb_str_to_inum (VALUE, int, int)
VALUE | rb_cstr2inum (const char *, int)
VALUE | rb_str2inum (VALUE, int)
VALUE | rb_big2str (VALUE, int)
long | rb_big2long (VALUE)
unsigned long | rb_big2ulong (VALUE)
void | rb_big_pack (VALUE val, unsigned long *buf, long num_longs)
VALUE | rb_big_unpack (unsigned long *buf, long num_longs)
int | rb_uv_to_utf8 (char[6], unsigned long)
VALUE | rb_dbl2big (double)
double | rb_big2dbl (VALUE)
VALUE | rb_big_cmp (VALUE, VALUE)
VALUE | rb_big_eq (VALUE, VALUE)
VALUE | rb_big_eql (VALUE, VALUE)
VALUE | rb_big_plus (VALUE, VALUE)
VALUE | rb_big_minus (VALUE, VALUE)
VALUE | rb_big_mul (VALUE, VALUE)
VALUE | rb_big_div (VALUE, VALUE)
VALUE | rb_big_idiv (VALUE, VALUE)
VALUE | rb_big_modulo (VALUE, VALUE)
VALUE | rb_big_divmod (VALUE, VALUE)
VALUE | rb_big_pow (VALUE, VALUE)
VALUE | rb_big_and (VALUE, VALUE)
VALUE | rb_big_or (VALUE, VALUE)
VALUE | rb_big_xor (VALUE, VALUE)
VALUE | rb_big_lshift (VALUE, VALUE)
VALUE | rb_big_rshift (VALUE, VALUE)
int | rb_integer_pack (VALUE val, void *words, size_t numwords, size_t wordsize, size_t nails, int flags)
VALUE | rb_integer_unpack (const void *words, size_t numwords, size_t wordsize, size_t nails, int flags)
size_t | rb_absint_size (VALUE val, int *nlz_bits_ret)
size_t | rb_absint_numwords (VALUE val, size_t word_numbits, size_t *nlz_bits_ret)
int | rb_absint_singlebit_p (VALUE val)
VALUE | rb_rational_raw (VALUE, VALUE)
VALUE | rb_rational_new (VALUE, VALUE)
VALUE | rb_Rational (VALUE, VALUE)
VALUE | rb_rational_num (VALUE rat)
VALUE | rb_rational_den (VALUE rat)
VALUE | rb_flt_rationalize_with_prec (VALUE, VALUE)
VALUE | rb_flt_rationalize (VALUE)
VALUE | rb_complex_raw (VALUE, VALUE)
VALUE | rb_complex_new (VALUE, VALUE)
VALUE | rb_complex_new_polar (VALUE abs, VALUE arg)
| DEPRECATED_BY (rb_complex_new_polar, VALUE rb_complex_polar(VALUE abs, VALUE arg))
VALUE | rb_complex_real (VALUE z)
VALUE | rb_complex_imag (VALUE z)
VALUE | rb_complex_plus (VALUE x, VALUE y)
VALUE | rb_complex_minus (VALUE x, VALUE y)
VALUE | rb_complex_mul (VALUE x, VALUE y)
VALUE | rb_complex_div (VALUE x, VALUE y)
VALUE | rb_complex_uminus (VALUE z)
VALUE | rb_complex_conjugate (VALUE z)
VALUE | rb_complex_abs (VALUE z)
VALUE | rb_complex_arg (VALUE z)
VALUE | rb_complex_pow (VALUE base, VALUE exp)
VALUE | rb_dbl_complex_new (double real, double imag)
| Creates a Complex object. More...
VALUE | rb_Complex (VALUE, VALUE)
VALUE | rb_class_new (VALUE)
| Creates a new class. More...
VALUE | rb_mod_init_copy (VALUE, VALUE)
VALUE | rb_singleton_class_clone (VALUE)
void | rb_singleton_class_attached (VALUE, VALUE)
| Attach a object to a singleton class. More...
void | rb_check_inheritable (VALUE)
| Ensures a class can be derived from super. More...
VALUE | rb_define_class_id (ID, VALUE)
| Defines a new class. More...
VALUE | rb_define_class_id_under (VALUE, ID, VALUE)
| Defines a class under the namespace of outer. More...
VALUE | rb_module_new (void)
VALUE | rb_define_module_id (ID)
VALUE | rb_define_module_id_under (VALUE, ID)
VALUE | rb_mod_included_modules (VALUE)
VALUE | rb_mod_include_p (VALUE, VALUE)
VALUE | rb_mod_ancestors (VALUE)
VALUE | rb_class_instance_methods (int, const VALUE *, VALUE)
VALUE | rb_class_public_instance_methods (int, const VALUE *, VALUE)
VALUE | rb_class_protected_instance_methods (int, const VALUE *, VALUE)
VALUE | rb_class_private_instance_methods (int, const VALUE *, VALUE)
VALUE | rb_obj_singleton_methods (int, const VALUE *, VALUE)
void | rb_define_method_id (VALUE, ID, VALUE(*)(ANYARGS), int)
void | rb_undef (VALUE, ID)
void | rb_define_protected_method (VALUE, const char *, VALUE(*)(ANYARGS), int)
void | rb_define_private_method (VALUE, const char *, VALUE(*)(ANYARGS), int)
void | rb_define_singleton_method (VALUE, const char *, VALUE(*)(ANYARGS), int)
| Defines a singleton method for obj. More...
VALUE | rb_singleton_class (VALUE)
| Returns the singleton class of obj. More...
int | rb_cmpint (VALUE, VALUE, VALUE)
| NORETURN (void rb_cmperr(VALUE, VALUE))
VALUE | rb_fiber_new (rb_block_call_func_t, VALUE)
VALUE | rb_fiber_resume (VALUE fib, int argc, const VALUE *argv)
VALUE | rb_fiber_resume_kw (VALUE fib, int argc, const VALUE *argv, int kw_splat)
VALUE | rb_fiber_yield (int argc, const VALUE *argv)
VALUE | rb_fiber_yield_kw (int argc, const VALUE *argv, int kw_splat)
VALUE | rb_fiber_current (void)
VALUE | rb_fiber_alive_p (VALUE)
VALUE | rb_enum_values_pack (int, const VALUE *)
VALUE | rb_enumeratorize (VALUE, VALUE, int, const VALUE *)
VALUE | rb_enumeratorize_with_size (VALUE, VALUE, int, const VALUE *, rb_enumerator_size_func *)
VALUE | rb_enumeratorize_with_size_kw (VALUE, VALUE, int, const VALUE *, rb_enumerator_size_func *, int)
int | rb_arithmetic_sequence_extract (VALUE, rb_arithmetic_sequence_components_t *)
VALUE | rb_exc_new (VALUE, const char *, long)
VALUE | rb_exc_new_cstr (VALUE, const char *)
VALUE | rb_exc_new_str (VALUE, VALUE)
| PRINTF_ARGS (NORETURN(void rb_loaderror(const char *,...)), 1, 2)
| PRINTF_ARGS (NORETURN(void rb_loaderror_with_path(VALUE path, const char *,...)), 2, 3)
| PRINTF_ARGS (NORETURN(void rb_name_error(ID, const char *,...)), 2, 3)
| PRINTF_ARGS (NORETURN(void rb_name_error_str(VALUE, const char *,...)), 2, 3)
| PRINTF_ARGS (NORETURN(void rb_frozen_error_raise(VALUE, const char *,...)), 2, 3)
| NORETURN (void rb_invalid_str(const char *, const char *))
| NORETURN (void rb_error_frozen(const char *))
| NORETURN (void rb_error_frozen_object(VALUE))
void | rb_error_untrusted (VALUE)
void | rb_check_frozen (VALUE)
void | rb_check_trusted (VALUE)
void | rb_check_copyable (VALUE obj, VALUE orig)
int | rb_sourceline (void)
const char * | rb_sourcefile (void)
VALUE | rb_check_funcall (VALUE, ID, int, const VALUE *)
VALUE | rb_check_funcall_kw (VALUE, ID, int, const VALUE *, int)
| NORETURN (MJIT_STATIC void rb_error_arity(int, int, int))
| NORETURN (VALUE rb_f_exit(int, const VALUE *))
void | rb_remove_method (VALUE, const char *)
void | rb_remove_method_id (VALUE, ID)
void | rb_define_alloc_func (VALUE, rb_alloc_func_t)
void | rb_undef_alloc_func (VALUE)
rb_alloc_func_t | rb_get_alloc_func (VALUE)
void | rb_clear_constant_cache (void)
void | rb_clear_method_cache_by_class (VALUE)
void | rb_alias (VALUE, ID, ID)
void | rb_attr (VALUE, ID, int, int, int)
int | rb_method_boundp (VALUE, ID, int)
int | rb_method_basic_definition_p (VALUE, ID)
VALUE | rb_eval_cmd (VALUE, VALUE, int)
VALUE | rb_eval_cmd_kw (VALUE, VALUE, int)
int | rb_obj_respond_to (VALUE, ID, int)
int | rb_respond_to (VALUE, ID)
| NORETURN (VALUE rb_f_notimplement(int argc, const VALUE *argv, VALUE obj, VALUE marker))
| NORETURN (void rb_interrupt(void))
VALUE | rb_apply (VALUE, ID, VALUE)
| Calls a method. More...
void | rb_backtrace (void)
ID | rb_frame_this_func (void)
| The original name of the current method. More...
VALUE | rb_obj_instance_eval (int, const VALUE *, VALUE)
VALUE | rb_obj_instance_exec (int, const VALUE *, VALUE)
VALUE | rb_mod_module_eval (int, const VALUE *, VALUE)
VALUE | rb_mod_module_exec (int, const VALUE *, VALUE)
void | rb_load (VALUE, int)
void | rb_load_protect (VALUE, int, int *)
| NORETURN (void rb_jump_tag(int))
int | rb_provided (const char *)
int | rb_feature_provided (const char *, const char **)
void | rb_provide (const char *)
VALUE | rb_f_require (VALUE, VALUE)
VALUE | rb_require_safe (VALUE, int)
VALUE | rb_require_string (VALUE)
void | rb_obj_call_init (VALUE, int, const VALUE *)
| Calls `#initialize` method of obj with the given arguments. More...
void | rb_obj_call_init_kw (VALUE, int, const VALUE *, int)
VALUE | rb_class_new_instance (int, const VALUE *, VALUE)
| Allocates and initializes an instance of klass. More...
VALUE | rb_class_new_instance_kw (int, const VALUE *, VALUE, int)
VALUE | rb_block_proc (void)
VALUE | rb_block_lambda (void)
VALUE | rb_proc_new (rb_block_call_func_t, VALUE)
VALUE | rb_obj_is_proc (VALUE)
VALUE | rb_proc_call (VALUE, VALUE)
VALUE | rb_proc_call_kw (VALUE, VALUE, int)
VALUE | rb_proc_call_with_block (VALUE, int argc, const VALUE *argv, VALUE)
VALUE | rb_proc_call_with_block_kw (VALUE, int argc, const VALUE *argv, VALUE, int)
int | rb_proc_arity (VALUE)
VALUE | rb_proc_lambda_p (VALUE)
VALUE | rb_binding_new (void)
VALUE | rb_obj_method (VALUE, VALUE)
VALUE | rb_obj_is_method (VALUE)
VALUE | rb_method_call (int, const VALUE *, VALUE)
VALUE | rb_method_call_kw (int, const VALUE *, VALUE, int)
VALUE | rb_method_call_with_block (int, const VALUE *, VALUE, VALUE)
VALUE | rb_method_call_with_block_kw (int, const VALUE *, VALUE, VALUE, int)
int | rb_mod_method_arity (VALUE, ID)
int | rb_obj_method_arity (VALUE, ID)
VALUE | rb_protect (VALUE(*)(VALUE), VALUE, int *)
| Protects a function call from potential global escapes from the function. More...
void | rb_set_end_proc (void(*)(VALUE), VALUE)
void | rb_thread_schedule (void)
void | rb_thread_wait_fd (int)
int | rb_thread_fd_writable (int)
void | rb_thread_fd_close (int)
int | rb_thread_alone (void)
void | rb_thread_sleep (int)
void | rb_thread_sleep_forever (void)
void | rb_thread_sleep_deadly (void)
VALUE | rb_thread_stop (void)
VALUE | rb_thread_wakeup (VALUE)
VALUE | rb_thread_wakeup_alive (VALUE)
VALUE | rb_thread_run (VALUE)
VALUE | rb_thread_kill (VALUE)
VALUE | rb_thread_create (VALUE(*)(void *), void *)
int | rb_thread_fd_select (int, rb_fdset_t *, rb_fdset_t *, rb_fdset_t *, struct timeval *)
void | rb_thread_wait_for (struct timeval)
VALUE | rb_thread_current (void)
VALUE | rb_thread_main (void)
VALUE | rb_thread_local_aref (VALUE, ID)
VALUE | rb_thread_local_aset (VALUE, ID, VALUE)
void | rb_thread_atfork (void)
void | rb_thread_atfork_before_exec (void)
VALUE | rb_exec_recursive (VALUE(*)(VALUE, VALUE, int), VALUE, VALUE)
VALUE | rb_exec_recursive_paired (VALUE(*)(VALUE, VALUE, int), VALUE, VALUE, VALUE)
VALUE | rb_exec_recursive_outer (VALUE(*)(VALUE, VALUE, int), VALUE, VALUE)
VALUE | rb_exec_recursive_paired_outer (VALUE(*)(VALUE, VALUE, int), VALUE, VALUE, VALUE)
VALUE | rb_dir_getwd (void)
VALUE | rb_file_s_expand_path (int, const VALUE *)
VALUE | rb_file_expand_path (VALUE, VALUE)
VALUE | rb_file_s_absolute_path (int, const VALUE *)
VALUE | rb_file_absolute_path (VALUE, VALUE)
VALUE | rb_file_dirname (VALUE fname)
int | rb_find_file_ext_safe (VALUE *, const char *const *, int)
VALUE | rb_find_file_safe (VALUE, int)
int | rb_find_file_ext (VALUE *, const char *const *)
VALUE | rb_find_file (VALUE)
VALUE | rb_file_directory_p (VALUE, VALUE)
VALUE | rb_str_encode_ospath (VALUE)
int | rb_is_absolute_path (const char *)
| PUREFUNC (int rb_during_gc(void))
void | rb_gc_mark_locations (const VALUE *, const VALUE *)
void | rb_mark_tbl (struct st_table *)
void | rb_mark_tbl_no_pin (struct st_table *)
void | rb_mark_set (struct st_table *)
void | rb_mark_hash (struct st_table *)
void | rb_gc_update_tbl_refs (st_table *ptr)
void | rb_gc_mark_maybe (VALUE)
void | rb_gc_mark (VALUE)
void | rb_gc_mark_movable (VALUE)
VALUE | rb_gc_location (VALUE)
void | rb_gc_force_recycle (VALUE)
void | rb_gc (void)
void | rb_gc_copy_finalizer (VALUE, VALUE)
VALUE | rb_gc_enable (void)
VALUE | rb_gc_disable (void)
VALUE | rb_gc_start (void)
VALUE | rb_define_finalizer (VALUE, VALUE)
VALUE | rb_undefine_finalizer (VALUE)
size_t | rb_gc_count (void)
size_t | rb_gc_stat (VALUE)
VALUE | rb_gc_latest_gc_info (VALUE)
void | rb_gc_adjust_memory_usage (ssize_t)
void | rb_st_foreach_safe (struct st_table *, int(*)(st_data_t, st_data_t, st_data_t), st_data_t)
VALUE | rb_check_hash_type (VALUE)
void | rb_hash_foreach (VALUE, int(*)(VALUE, VALUE, VALUE), VALUE)
VALUE | rb_hash (VALUE)
VALUE | rb_hash_new (void)
VALUE | rb_hash_dup (VALUE)
VALUE | rb_hash_freeze (VALUE)
VALUE | rb_hash_aref (VALUE, VALUE)
VALUE | rb_hash_lookup (VALUE, VALUE)
VALUE | rb_hash_lookup2 (VALUE, VALUE, VALUE)
VALUE | rb_hash_fetch (VALUE, VALUE)
VALUE | rb_hash_aset (VALUE, VALUE, VALUE)
VALUE | rb_hash_clear (VALUE)
VALUE | rb_hash_delete_if (VALUE)
VALUE | rb_hash_delete (VALUE, VALUE)
VALUE | rb_hash_set_ifnone (VALUE hash, VALUE ifnone)
void | rb_hash_bulk_insert (long, const VALUE *, VALUE)
VALUE | rb_hash_update_by (VALUE hash1, VALUE hash2, rb_hash_update_func *func)
struct st_table * | rb_hash_tbl (VALUE, const char *file, int line)
int | rb_path_check (const char *)
int | rb_env_path_tainted (void)
VALUE | rb_env_clear (void)
VALUE | rb_hash_size (VALUE)
void | rb_hash_free (VALUE)
VALUE | rb_io_write (VALUE, VALUE)
VALUE | rb_io_gets (VALUE)
VALUE | rb_io_getbyte (VALUE)
VALUE | rb_io_ungetc (VALUE, VALUE)
VALUE | rb_io_ungetbyte (VALUE, VALUE)
VALUE | rb_io_close (VALUE)
VALUE | rb_io_flush (VALUE)
VALUE | rb_io_eof (VALUE)
VALUE | rb_io_binmode (VALUE)
VALUE | rb_io_ascii8bit_binmode (VALUE)
VALUE | rb_io_addstr (VALUE, VALUE)
VALUE | rb_io_printf (int, const VALUE *, VALUE)
VALUE | rb_io_print (int, const VALUE *, VALUE)
VALUE | rb_io_puts (int, const VALUE *, VALUE)
VALUE | rb_io_fdopen (int, int, const char *)
VALUE | rb_io_get_io (VALUE)
VALUE | rb_file_open (const char *, const char *)
VALUE | rb_file_open_str (VALUE, const char *)
VALUE | rb_gets (void)
void | rb_write_error (const char *)
void | rb_write_error2 (const char *, long)
void | rb_close_before_exec (int lowfd, int maxhint, VALUE noclose_fds)
int | rb_pipe (int *pipes)
int | rb_reserved_fd_p (int fd)
int | rb_cloexec_open (const char *pathname, int flags, mode_t mode)
int | rb_cloexec_dup (int oldfd)
int | rb_cloexec_dup2 (int oldfd, int newfd)
int | rb_cloexec_pipe (int fildes[2])
int | rb_cloexec_fcntl_dupfd (int fd, int minfd)
void | rb_update_max_fd (int fd)
void | rb_fd_fix_cloexec (int fd)
VALUE | rb_marshal_dump (VALUE, VALUE)
VALUE | rb_marshal_load (VALUE)
void | rb_marshal_define_compat (VALUE newclass, VALUE oldclass, VALUE(*dumper)(VALUE), VALUE(*loader)(VALUE, VALUE))
VALUE | rb_num_coerce_bin (VALUE, VALUE, ID)
VALUE | rb_num_coerce_cmp (VALUE, VALUE, ID)
VALUE | rb_num_coerce_relop (VALUE, VALUE, ID)
VALUE | rb_num_coerce_bit (VALUE, VALUE, ID)
VALUE | rb_num2fix (VALUE)
VALUE | rb_fix2str (VALUE, int)
| CONSTFUNC (VALUE rb_dbl_cmp(double, double))
int | rb_eql (VALUE, VALUE)
| Determines if obj1 and obj2 are equal in terms of `Object::eql`?. More...
VALUE | rb_any_to_s (VALUE)
| Default implementation of `#to_s`. More...
VALUE | rb_inspect (VALUE)
| Convenient wrapper of `Object::inspect`. More...
VALUE | rb_obj_is_instance_of (VALUE, VALUE)
| Determines if obj is an instance of c. More...
VALUE | rb_obj_is_kind_of (VALUE, VALUE)
| Determines if obj is a kind of c. More...
VALUE | rb_obj_alloc (VALUE)
| Allocates an instance of klass. More...
VALUE | rb_obj_clone (VALUE)
| Almost same as `Object::clone`. More...
VALUE | rb_obj_dup (VALUE)
| Equivalent to `Object#dup` in Ruby. More...
VALUE | rb_obj_init_copy (VALUE, VALUE)
| Default implementation of `#initialize_copy`. More...
VALUE | rb_obj_taint (VALUE)
| call-seq: obj.taint -> obj More...
| PUREFUNC (VALUE rb_obj_tainted(VALUE))
VALUE | rb_obj_untaint (VALUE)
| call-seq: obj.untaint -> obj More...
VALUE | rb_obj_untrust (VALUE)
| call-seq: obj.untrust -> obj More...
VALUE | rb_obj_trust (VALUE)
| call-seq: obj.trust -> obj More...
VALUE | rb_obj_freeze (VALUE)
| Make the object unmodifiable. More...
VALUE | rb_obj_id (VALUE)
VALUE | rb_memory_id (VALUE)
VALUE | rb_obj_class (VALUE)
| Equivalent to `Object#class` in Ruby. More...
| PUREFUNC (VALUE rb_class_inherited_p(VALUE, VALUE))
VALUE | rb_class_superclass (VALUE)
| Returns the superclass of klass. More...
VALUE | rb_class_get_superclass (VALUE)
| Returns the superclass of klass The return value might be an iclass of a module, unlike rb_class_superclass. More...
VALUE | rb_convert_type (VALUE, int, const char *, const char *)
| Converts an object into another type. More...
VALUE | rb_check_convert_type (VALUE, int, const char *, const char *)
| Tries to convert an object into another type. More...
VALUE | rb_check_to_integer (VALUE, const char *)
| Tries to convert val into `Integer`. More...
VALUE | rb_check_to_float (VALUE)
| Tries to convert an object into `Float`. More...
VALUE | rb_to_int (VALUE)
| Converts val into `Integer`. More...
VALUE | rb_check_to_int (VALUE)
| Tries to convert val into Integer. More...
VALUE | rb_Integer (VALUE)
| Equivalent to `Kernel#Integer` in Ruby. More...
VALUE | rb_to_float (VALUE)
| Converts a `Numeric` object into `Float`. More...
VALUE | rb_Float (VALUE)
| Equivalent to `Kernel#Float` in Ruby. More...
VALUE | rb_String (VALUE)
| Equivalent to `Kernel#String` in Ruby. More...
VALUE | rb_Array (VALUE)
| Equivalent to `Kernel#Array` in Ruby. More...
VALUE | rb_Hash (VALUE)
| Equivalent to `Kernel#Hash` in Ruby. More...
double | rb_cstr_to_dbl (const char *, int)
| Parses a string representation of a floating point number. More...
double | rb_str_to_dbl (VALUE, int)
| Parses a string representation of a floating point number. More...
ID | rb_id_attrset (ID)
| CONSTFUNC (int rb_is_const_id(ID))
int | rb_symname_p (const char *)
int | rb_sym_interned_p (VALUE)
VALUE | rb_backref_get (void)
void | rb_backref_set (VALUE)
VALUE | rb_lastline_get (void)
void | rb_lastline_set (VALUE)
void | rb_last_status_set (int status, rb_pid_t pid)
VALUE | rb_last_status_get (void)
int | rb_proc_exec (const char *)
rb_pid_t | rb_waitpid (rb_pid_t pid, int *status, int flags)
void | rb_syswait (rb_pid_t pid)
rb_pid_t | rb_spawn (int, const VALUE *)
rb_pid_t | rb_spawn_err (int, const VALUE *, char *, size_t)
VALUE | rb_proc_times (VALUE)
VALUE | rb_detach_process (rb_pid_t pid)
VALUE | rb_range_new (VALUE, VALUE, int)
VALUE | rb_range_beg_len (VALUE, long *, long *, long, int)
int | rb_range_values (VALUE range, VALUE *begp, VALUE *endp, int *exclp)
unsigned int | rb_genrand_int32 (void)
double | rb_genrand_real (void)
void | rb_reset_random_seed (void)
VALUE | rb_random_bytes (VALUE rnd, long n)
VALUE | rb_random_int (VALUE rnd, VALUE max)
unsigned int | rb_random_int32 (VALUE rnd)
double | rb_random_real (VALUE rnd)
unsigned long | rb_random_ulong_limited (VALUE rnd, unsigned long limit)
unsigned long | rb_genrand_ulong_limited (unsigned long i)
int | rb_memcicmp (const void *, const void *, long)
void | rb_match_busy (VALUE)
VALUE | rb_reg_nth_defined (int, VALUE)
VALUE | rb_reg_nth_match (int, VALUE)
int | rb_reg_backref_number (VALUE match, VALUE backref)
VALUE | rb_reg_last_match (VALUE)
VALUE | rb_reg_match_pre (VALUE)
VALUE | rb_reg_match_post (VALUE)
VALUE | rb_reg_match_last (VALUE)
VALUE | rb_reg_new_str (VALUE, int)
VALUE | rb_reg_new (const char *, long, int)
VALUE | rb_reg_alloc (void)
VALUE | rb_reg_init_str (VALUE re, VALUE s, int options)
VALUE | rb_reg_match (VALUE, VALUE)
VALUE | rb_reg_match2 (VALUE)
int | rb_reg_options (VALUE)
VALUE | rb_get_argv (void)
void * | rb_load_file (const char *)
void * | rb_load_file_str (VALUE)
VALUE | rb_f_kill (int, const VALUE *)
const char * | ruby_signal_name (int)
void | ruby_default_signal (int)
VALUE | rb_f_sprintf (int, const VALUE *)
| PRINTF_ARGS (VALUE rb_sprintf(const char *,...), 1, 2)
VALUE | rb_vsprintf (const char *, va_list)
| PRINTF_ARGS (VALUE rb_str_catf(VALUE, const char *,...), 2, 3)
VALUE | rb_str_vcatf (VALUE, const char *, va_list)
VALUE | rb_str_format (int, const VALUE *, VALUE)
VALUE | rb_str_new (const char *, long)
VALUE | rb_str_new_cstr (const char *)
VALUE | rb_str_new_shared (VALUE)
VALUE | rb_str_new_frozen (VALUE)
VALUE | rb_str_new_with_class (VALUE, const char *, long)
VALUE | rb_tainted_str_new_cstr (const char *)
VALUE | rb_tainted_str_new (const char *, long)
VALUE | rb_external_str_new (const char *, long)
VALUE | rb_external_str_new_cstr (const char *)
VALUE | rb_locale_str_new (const char *, long)
VALUE | rb_locale_str_new_cstr (const char *)
VALUE | rb_filesystem_str_new (const char *, long)
VALUE | rb_filesystem_str_new_cstr (const char *)
VALUE | rb_str_buf_new (long)
VALUE | rb_str_buf_new_cstr (const char *)
VALUE | rb_str_buf_new2 (const char *)
VALUE | rb_str_tmp_new (long)
VALUE | rb_usascii_str_new (const char *, long)
VALUE | rb_usascii_str_new_cstr (const char *)
VALUE | rb_utf8_str_new (const char *, long)
VALUE | rb_utf8_str_new_cstr (const char *)
VALUE | rb_str_new_static (const char *, long)
VALUE | rb_usascii_str_new_static (const char *, long)
VALUE | rb_utf8_str_new_static (const char *, long)
void | rb_str_free (VALUE)
void | rb_str_shared_replace (VALUE, VALUE)
VALUE | rb_str_buf_append (VALUE, VALUE)
VALUE | rb_str_buf_cat (VALUE, const char *, long)
VALUE | rb_str_buf_cat2 (VALUE, const char *)
VALUE | rb_str_buf_cat_ascii (VALUE, const char *)
VALUE | rb_obj_as_string (VALUE)
VALUE | rb_check_string_type (VALUE)
void | rb_must_asciicompat (VALUE)
VALUE | rb_str_dup (VALUE)
VALUE | rb_str_resurrect (VALUE str)
VALUE | rb_str_locktmp (VALUE)
VALUE | rb_str_unlocktmp (VALUE)
VALUE | rb_str_dup_frozen (VALUE)
VALUE | rb_str_plus (VALUE, VALUE)
VALUE | rb_str_times (VALUE, VALUE)
long | rb_str_sublen (VALUE, long)
VALUE | rb_str_substr (VALUE, long, long)
VALUE | rb_str_subseq (VALUE, long, long)
char * | rb_str_subpos (VALUE, long, long *)
void | rb_str_modify (VALUE)
void | rb_str_modify_expand (VALUE, long)
VALUE | rb_str_freeze (VALUE)
void | rb_str_set_len (VALUE, long)
VALUE | rb_str_resize (VALUE, long)
VALUE | rb_str_cat (VALUE, const char *, long)
VALUE | rb_str_cat_cstr (VALUE, const char *)
VALUE | rb_str_cat2 (VALUE, const char *)
VALUE | rb_str_append (VALUE, VALUE)
VALUE | rb_str_concat (VALUE, VALUE)
st_index_t | rb_memhash (const void *ptr, long len)
st_index_t | rb_hash_start (st_index_t)
st_index_t | rb_hash_uint32 (st_index_t, uint32_t)
st_index_t | rb_hash_uint (st_index_t, st_index_t)
st_index_t | rb_hash_end (st_index_t)
st_index_t | rb_str_hash (VALUE)
int | rb_str_hash_cmp (VALUE, VALUE)
int | rb_str_comparable (VALUE, VALUE)
int | rb_str_cmp (VALUE, VALUE)
VALUE | rb_str_equal (VALUE str1, VALUE str2)
VALUE | rb_str_drop_bytes (VALUE, long)
void | rb_str_update (VALUE, long, long, VALUE)
VALUE | rb_str_replace (VALUE, VALUE)
VALUE | rb_str_inspect (VALUE)
VALUE | rb_str_dump (VALUE)
VALUE | rb_str_split (VALUE, const char *)
VALUE | rb_str_intern (VALUE)
VALUE | rb_sym_to_s (VALUE)
long | rb_str_strlen (VALUE)
VALUE | rb_str_length (VALUE)
long | rb_str_offset (VALUE, long)
| PUREFUNC (size_t rb_str_capacity(VALUE))
VALUE | rb_str_ellipsize (VALUE, long)
| Shortens str and adds three dots, an ellipsis, if it is longer than len characters. More...
VALUE | rb_str_scrub (VALUE, VALUE)
VALUE | rb_sym_all_symbols (void)
VALUE | rb_struct_new (VALUE,...)
VALUE | rb_struct_define (const char *,...)
VALUE | rb_struct_define_under (VALUE, const char *,...)
VALUE | rb_struct_alloc (VALUE, VALUE)
VALUE | rb_struct_initialize (VALUE, VALUE)
VALUE | rb_struct_aref (VALUE, VALUE)
VALUE | rb_struct_aset (VALUE, VALUE, VALUE)
VALUE | rb_struct_getmember (VALUE, ID)
VALUE | rb_struct_s_members (VALUE)
VALUE | rb_struct_members (VALUE)
VALUE | rb_struct_size (VALUE s)
VALUE | rb_struct_alloc_noinit (VALUE)
VALUE | rb_struct_define_without_accessor (const char *, VALUE, rb_alloc_func_t,...)
VALUE | rb_struct_define_without_accessor_under (VALUE outer, const char *class_name, VALUE super, rb_alloc_func_t alloc,...)
void | rb_thread_check_ints (void)
int | rb_thread_interrupted (VALUE thval)
VALUE | rb_mutex_new (void)
VALUE | rb_mutex_locked_p (VALUE mutex)
VALUE | rb_mutex_trylock (VALUE mutex)
VALUE | rb_mutex_lock (VALUE mutex)
VALUE | rb_mutex_unlock (VALUE mutex)
VALUE | rb_mutex_sleep (VALUE self, VALUE timeout)
VALUE | rb_mutex_synchronize (VALUE mutex, VALUE(*func)(VALUE arg), VALUE arg)
void | rb_timespec_now (struct timespec *)
VALUE | rb_time_new (time_t, long)
VALUE | rb_time_nano_new (time_t, long)
VALUE | rb_time_timespec_new (const struct timespec *, int)
| Returns a time object with UTC/localtime/fixed offset. More...
VALUE | rb_time_num_new (VALUE, VALUE)
struct timeval | rb_time_interval (VALUE num)
struct timeval | rb_time_timeval (VALUE time)
struct timespec | rb_time_timespec (VALUE time)
struct timespec | rb_time_timespec_interval (VALUE num)
VALUE | rb_time_utc_offset (VALUE time)
VALUE | rb_mod_name (VALUE)
VALUE | rb_class_path (VALUE)
VALUE | rb_class_path_cached (VALUE)
void | rb_set_class_path (VALUE, VALUE, const char *)
void | rb_set_class_path_string (VALUE, VALUE, VALUE)
VALUE | rb_path_to_class (VALUE)
VALUE | rb_path2class (const char *)
VALUE | rb_class_name (VALUE)
VALUE | rb_autoload_load (VALUE, ID)
VALUE | rb_autoload_p (VALUE, ID)
VALUE | rb_f_trace_var (int, const VALUE *)
VALUE | rb_f_untrace_var (int, const VALUE *)
VALUE | rb_f_global_variables (void)
void | rb_alias_variable (ID, ID)
void | rb_copy_generic_ivar (VALUE, VALUE)
void | rb_free_generic_ivar (VALUE)
VALUE | rb_ivar_get (VALUE, ID)
VALUE | rb_ivar_set (VALUE, ID, VALUE)
VALUE | rb_ivar_defined (VALUE, ID)
void | rb_ivar_foreach (VALUE, int(*)(ID, VALUE, st_data_t), st_data_t)
st_index_t | rb_ivar_count (VALUE)
VALUE | rb_attr_get (VALUE, ID)
VALUE | rb_obj_instance_variables (VALUE)
VALUE | rb_obj_remove_instance_variable (VALUE, VALUE)
void * | rb_mod_const_at (VALUE, void *)
void * | rb_mod_const_of (VALUE, void *)
VALUE | rb_const_list (void *)
VALUE | rb_mod_constants (int, const VALUE *, VALUE)
VALUE | rb_mod_remove_const (VALUE, VALUE)
int | rb_const_defined (VALUE, ID)
int | rb_const_defined_at (VALUE, ID)
int | rb_const_defined_from (VALUE, ID)
VALUE | rb_const_get (VALUE, ID)
VALUE | rb_const_get_at (VALUE, ID)
VALUE | rb_const_get_from (VALUE, ID)
void | rb_const_set (VALUE, ID, VALUE)
VALUE | rb_const_remove (VALUE, ID)
VALUE | rb_cvar_defined (VALUE, ID)
void | rb_cvar_set (VALUE, ID, VALUE)
VALUE | rb_cvar_get (VALUE, ID)
void | rb_cv_set (VALUE, const char *, VALUE)
VALUE | rb_cv_get (VALUE, const char *)
void | rb_define_class_variable (VALUE, const char *, VALUE)
VALUE | rb_mod_class_variables (int, const VALUE *, VALUE)
VALUE | rb_mod_remove_cvar (VALUE, VALUE)
ID | rb_frame_callee (void)
| The name of the current method. More...
int | rb_frame_method_id_and_class (ID *idp, VALUE *klassp)
VALUE | rb_str_succ (VALUE)
VALUE | rb_time_succ (VALUE)
VALUE | rb_make_backtrace (void)
VALUE | rb_make_exception (int, const VALUE *)
| Make an `Exception` object from the list of arguments in a manner similar to `Kernel#raise`. More...

## Variables
RUBY_EXTERN VALUE | rb_fs
RUBY_EXTERN VALUE | rb_output_fs
RUBY_EXTERN VALUE | rb_rs
RUBY_EXTERN VALUE | rb_default_rs
RUBY_EXTERN VALUE | rb_output_rs
RUBY_EXTERN VALUE | rb_argv0
rb_gvar_setter_t | rb_str_setter

## Macro Definition Documentation

## ◆ __has_attribute

#define __has_attribute | ( |  | x | ) | 0

Definition at line 25 of file intern.h.

## ◆ HAVE_RB_DEFINE_ALLOC_FUNC

#define HAVE_RB_DEFINE_ALLOC_FUNC 1

Definition at line 426 of file intern.h.

## ◆ HAVE_RB_REG_NEW_STR

#define HAVE_RB_REG_NEW_STR 1

Definition at line 724 of file intern.h.

## ◆ INTEGER_PACK_2COMP

#define INTEGER_PACK_2COMP 0x80

Definition at line 156 of file intern.h.

## ◆ INTEGER_PACK_BIG_ENDIAN

#define INTEGER_PACK_BIG_ENDIAN

Value:
(INTEGER_PACK_MSWORD_FIRST | \
INTEGER_PACK_MSBYTE_FIRST)

Definition at line 165 of file intern.h.

## ◆ INTEGER_PACK_FORCE_BIGNUM

#define INTEGER_PACK_FORCE_BIGNUM 0x100

Definition at line 159 of file intern.h.

## ◆ INTEGER_PACK_FORCE_GENERIC_IMPLEMENTATION

#define INTEGER_PACK_FORCE_GENERIC_IMPLEMENTATION 0x400

Definition at line 157 of file intern.h.

## ◆ INTEGER_PACK_LITTLE_ENDIAN

#define INTEGER_PACK_LITTLE_ENDIAN

Value:
(INTEGER_PACK_LSWORD_FIRST | \
INTEGER_PACK_LSBYTE_FIRST)

Definition at line 162 of file intern.h.

## ◆ INTEGER_PACK_LSBYTE_FIRST

#define INTEGER_PACK_LSBYTE_FIRST 0x20

Definition at line 154 of file intern.h.

## ◆ INTEGER_PACK_LSWORD_FIRST

#define INTEGER_PACK_LSWORD_FIRST 0x02

Definition at line 152 of file intern.h.

## ◆ INTEGER_PACK_MSBYTE_FIRST

#define INTEGER_PACK_MSBYTE_FIRST 0x10

Definition at line 153 of file intern.h.

## ◆ INTEGER_PACK_MSWORD_FIRST

#define INTEGER_PACK_MSWORD_FIRST 0x01

Definition at line 151 of file intern.h.

## ◆ INTEGER_PACK_NATIVE_BYTE_ORDER

#define INTEGER_PACK_NATIVE_BYTE_ORDER 0x40

Definition at line 155 of file intern.h.

## ◆ INTEGER_PACK_NEGATIVE

#define INTEGER_PACK_NEGATIVE 0x200

Definition at line 160 of file intern.h.

## ◆ MJIT_STATIC

#define MJIT_STATIC

Definition at line 47 of file intern.h.

## ◆ OBJ_INIT_COPY

#define OBJ_INIT_COPY | ( |  | obj,
|  |  | orig
| ) |  | RB_OBJ_INIT_COPY(obj, orig)

Definition at line 331 of file intern.h.

## ◆ rb_argv

#define rb_argv rb_get_argv()

Definition at line 733 of file intern.h.

## ◆ rb_ary_new2

#define rb_ary_new2 rb_ary_new_capa

Definition at line 103 of file intern.h.

## ◆ rb_ary_new3

#define rb_ary_new3 rb_ary_new_from_args

Definition at line 104 of file intern.h.

## ◆ rb_ary_new4

#define rb_ary_new4 rb_ary_new_from_values

Definition at line 105 of file intern.h.

## ◆ rb_big2int

#define rb_big2int | ( |  | x | ) | rb_big2long(x)

Definition at line 119 of file intern.h.

## ◆ rb_big2uint

#define rb_big2uint | ( |  | x | ) | rb_big2ulong(x)

Definition at line 121 of file intern.h.

## ◆ rb_check_arity

#define rb_check_arity rb_check_arity /* for ifdef */

Definition at line 347 of file intern.h.

## ◆ rb_check_frozen

#define rb_check_frozen | ( |  | obj | ) | rb_check_frozen_inline(obj)

Definition at line 319 of file intern.h.

## ◆ rb_check_frozen_internal

#define rb_check_frozen_internal | ( |  | obj | ) |

Value:
do { \
VALUE frozen_obj = (obj); \
if (RB_UNLIKELY(RB_OBJ_FROZEN(frozen_obj))) { \
rb_error_frozen_object(frozen_obj); \
} \
} while (0)

Definition at line 305 of file intern.h.

## ◆ rb_check_trusted

#define rb_check_trusted | ( |  | obj | ) | rb_check_trusted_inline(obj)

Definition at line 325 of file intern.h.

## ◆ rb_Complex1

#define rb_Complex1 | ( |  | x | ) | rb_Complex((x), INT2FIX(0))

Definition at line 214 of file intern.h.

## ◆ rb_Complex2

#define rb_Complex2 | ( |  | x,
|  |  | y
| ) |  | rb_Complex((x), (y))

Definition at line 215 of file intern.h.

## ◆ rb_complex_add

#define rb_complex_add rb_complex_plus

Definition at line 209 of file intern.h.

## ◆ rb_complex_nagate

#define rb_complex_nagate rb_complex_uminus

Definition at line 211 of file intern.h.

## ◆ rb_complex_new1

#define rb_complex_new1 | ( |  | x | ) | rb_complex_new((x), INT2FIX(0))

Definition at line 193 of file intern.h.

## ◆ rb_complex_new2

#define rb_complex_new2 | ( |  | x,
|  |  | y
| ) |  | rb_complex_new((x), (y))

Definition at line 194 of file intern.h.

## ◆ rb_complex_raw1

#define rb_complex_raw1 | ( |  | x | ) | rb_complex_raw((x), INT2FIX(0))

Definition at line 190 of file intern.h.

## ◆ rb_complex_raw2

#define rb_complex_raw2 | ( |  | x,
|  |  | y
| ) |  | rb_complex_raw((x), (y))

Definition at line 191 of file intern.h.

## ◆ rb_complex_sub

#define rb_complex_sub rb_complex_minus

Definition at line 210 of file intern.h.

## ◆ rb_defout

#define rb_defout rb_stdout

Definition at line 582 of file intern.h.

## ◆ rb_enc_str_new_lit

#define rb_enc_str_new_lit | ( |  | str,
|  |  | enc
| ) |  | rb_enc_str_new_static((str), rb_strlen_lit(str), (enc))

Definition at line 917 of file intern.h.

## ◆ rb_enc_str_new_literal

#define rb_enc_str_new_literal | ( |  | str,
|  |  | enc
| ) |  | rb_enc_str_new_lit(str, enc)

Definition at line 921 of file intern.h.

## ◆ rb_enumeratorize_with_size

#define rb_enumeratorize_with_size | ( |  | obj,
|  |  | id,
|  |  | argc,
|  |  | argv,
|  |  | size_fn
| ) |  | rb_enumeratorize_with_size(obj, id, argc, argv, (rb_enumerator_size_func *)(size_fn))

Definition at line 260 of file intern.h.

## ◆ rb_enumeratorize_with_size_kw

#define rb_enumeratorize_with_size_kw | ( |  | obj,
|  |  | id,
|  |  | argc,
|  |  | argv,
|  |  | size_fn,
|  |  | kw_splat
| ) |  | rb_enumeratorize_with_size_kw(obj, id, argc, argv, (rb_enumerator_size_func *)(size_fn), kw_splat)

Definition at line 262 of file intern.h.

## ◆ rb_exc_new2

#define rb_exc_new2 rb_exc_new_cstr

Definition at line 292 of file intern.h.

## ◆ rb_exc_new3

#define rb_exc_new3 rb_exc_new_str

Definition at line 293 of file intern.h.

## ◆ rb_f_notimplement_p

#define rb_f_notimplement_p | ( |  | f | ) | 0

Definition at line 1036 of file intern.h.

## ◆ rb_fd_clr

#define rb_fd_clr | ( |  | n,
|  |  | f
| ) |  | FD_CLR((n), (f))

Definition at line 406 of file intern.h.

## ◆ rb_fd_copy

#define rb_fd_copy | ( |  | d,
|  |  | s,
|  |  | n
| ) |  | (*(d) = *(s))

Definition at line 408 of file intern.h.

## ◆ rb_fd_dup

#define rb_fd_dup | ( |  | d,
|  |  | s
| ) |  | (*(d) = *(s))

Definition at line 409 of file intern.h.

## ◆ rb_fd_init

#define rb_fd_init | ( |  | f | ) | FD_ZERO(f)

Definition at line 412 of file intern.h.

## ◆ rb_fd_init_copy

#define rb_fd_init_copy | ( |  | d,
|  |  | s
| ) |  | (*(d) = *(s))

Definition at line 413 of file intern.h.

## ◆ rb_fd_isset

#define rb_fd_isset | ( |  | n,
|  |  | f
| ) |  | FD_ISSET((n), (f))

Definition at line 407 of file intern.h.

## ◆ rb_fd_max

#define rb_fd_max | ( |  | f | ) | FD_SETSIZE

Definition at line 415 of file intern.h.

## ◆ rb_fd_ptr

#define rb_fd_ptr | ( |  | f | ) | (f)

Definition at line 411 of file intern.h.

## ◆ rb_fd_resize

#define rb_fd_resize | ( |  | n,
|  |  | f
| ) |  | ((void)(f))

Definition at line 410 of file intern.h.

## ◆ rb_fd_select

#define rb_fd_select | ( |  | n,
|  |  | rfds,
|  |  | wfds,
|  |  | efds,
|  |  | timeout
| ) |  | select((n), (rfds), (wfds), (efds), (timeout))

Definition at line 416 of file intern.h.

## ◆ rb_fd_set

#define rb_fd_set | ( |  | n,
|  |  | f
| ) |  | FD_SET((n), (f))

Definition at line 405 of file intern.h.

## ◆ rb_fd_term

#define rb_fd_term | ( |  | f | ) | ((void)(f))

Definition at line 414 of file intern.h.

## ◆ rb_fd_zero

#define rb_fd_zero | ( |  | f | ) | FD_ZERO(f)

Definition at line 404 of file intern.h.

## ◆ rb_hash_end

#define rb_hash_end | ( |  | h | ) | st_hash_end(h)

Definition at line 816 of file intern.h.

## ◆ rb_hash_uint

#define rb_hash_uint | ( |  | h,
|  |  | i
| ) |  | st_hash_uint((h), (i))

Definition at line 815 of file intern.h.

## ◆ rb_hash_uint32

#define rb_hash_uint32 | ( |  | h,
|  |  | i
| ) |  | st_hash_uint32((h), (i))

Definition at line 814 of file intern.h.

## ◆ rb_memcmp

#define rb_memcmp memcmp

Definition at line 714 of file intern.h.

## ◆ RB_NUM_COERCE_FUNCS_NEED_OPID

#define RB_NUM_COERCE_FUNCS_NEED_OPID 1

Definition at line 626 of file intern.h.

## ◆ RB_OBJ_INIT_COPY

#define RB_OBJ_INIT_COPY | ( |  | obj,
|  |  | orig
| ) |  | ((obj) != (orig) && (rb_obj_init_copy((obj), (orig)), 1))

Definition at line 329 of file intern.h.

## ◆ rb_Rational1

#define rb_Rational1 | ( |  | x | ) | rb_Rational((x), INT2FIX(1))

Definition at line 182 of file intern.h.

## ◆ rb_Rational2

#define rb_Rational2 | ( |  | x,
|  |  | y
| ) |  | rb_Rational((x), (y))

Definition at line 183 of file intern.h.

## ◆ rb_rational_new1

#define rb_rational_new1 | ( |  | x | ) | rb_rational_new((x), INT2FIX(1))

Definition at line 179 of file intern.h.

## ◆ rb_rational_new2

#define rb_rational_new2 | ( |  | x,
|  |  | y
| ) |  | rb_rational_new((x), (y))

Definition at line 180 of file intern.h.

## ◆ rb_rational_raw1

#define rb_rational_raw1 | ( |  | x | ) | rb_rational_raw((x), INT2FIX(1))

Definition at line 176 of file intern.h.

## ◆ rb_rational_raw2

#define rb_rational_raw2 | ( |  | x,
|  |  | y
| ) |  | rb_rational_raw((x), (y))

Definition at line 177 of file intern.h.

## ◆ RB_RESERVED_FD_P

#define RB_RESERVED_FD_P | ( |  | fd | ) | rb_reserved_fd_p(fd)

Definition at line 617 of file intern.h.

## ◆ rb_str_buf_cat

#define rb_str_buf_cat rb_str_cat

Definition at line 910 of file intern.h.

## ◆ rb_str_buf_cat2

#define rb_str_buf_cat2 rb_str_cat_cstr

Definition at line 911 of file intern.h.

## ◆ rb_str_buf_new2

#define rb_str_buf_new2 rb_str_buf_new_cstr

Definition at line 908 of file intern.h.

## ◆ rb_str_cat2

#define rb_str_cat2 rb_str_cat_cstr

Definition at line 912 of file intern.h.

## ◆ rb_str_dup_frozen

#define rb_str_dup_frozen rb_str_new_frozen

Definition at line 792 of file intern.h.

## ◆ rb_str_new2

#define rb_str_new2 rb_str_new_cstr

Definition at line 903 of file intern.h.

## ◆ rb_str_new3

#define rb_str_new3 rb_str_new_shared

Definition at line 904 of file intern.h.

## ◆ rb_str_new4

#define rb_str_new4 rb_str_new_frozen

Definition at line 905 of file intern.h.

## ◆ rb_str_new5

#define rb_str_new5 rb_str_new_with_class

Definition at line 906 of file intern.h.

## ◆ rb_str_new_lit

#define rb_str_new_lit | ( |  | str | ) | rb_str_new_static((str), rb_strlen_lit(str))

Definition at line 914 of file intern.h.

## ◆ rb_str_new_literal

#define rb_str_new_literal | ( |  | str | ) | rb_str_new_lit(str)

Definition at line 918 of file intern.h.

## ◆ rb_strlen_lit

#define rb_strlen_lit | ( |  | str | ) | (sizeof(str "") - 1)

Definition at line 913 of file intern.h.

## ◆ rb_tainted_str_new2

#define rb_tainted_str_new2 rb_tainted_str_new_cstr

Definition at line 907 of file intern.h.

## ◆ rb_usascii_str_new2

#define rb_usascii_str_new2 rb_usascii_str_new_cstr

Definition at line 909 of file intern.h.

## ◆ rb_usascii_str_new_lit

#define rb_usascii_str_new_lit | ( |  | str | ) | rb_usascii_str_new_static((str), rb_strlen_lit(str))

Definition at line 915 of file intern.h.

## ◆ rb_usascii_str_new_literal

#define rb_usascii_str_new_literal | ( |  | str | ) | rb_usascii_str_new_lit(str)

Definition at line 919 of file intern.h.

## ◆ rb_utf8_str_new_lit

#define rb_utf8_str_new_lit | ( |  | str | ) | rb_utf8_str_new_static((str), rb_strlen_lit(str))

Definition at line 916 of file intern.h.

## ◆ rb_utf8_str_new_literal

#define rb_utf8_str_new_literal | ( |  | str | ) | rb_utf8_str_new_lit(str)

Definition at line 920 of file intern.h.

## ◆ RETURN_ENUMERATOR

#define RETURN_ENUMERATOR | ( |  | obj,
|  |  | argc,
|  |  | argv
| ) |  | RETURN_SIZED_ENUMERATOR(obj, argc, argv, 0)

Definition at line 279 of file intern.h.

## ◆ RETURN_ENUMERATOR_KW

#define RETURN_ENUMERATOR_KW | ( |  | obj,
|  |  | argc,
|  |  | argv,
|  |  | kw_splat
| ) |  | RETURN_SIZED_ENUMERATOR_KW(obj, argc, argv, 0, kw_splat)

Definition at line 280 of file intern.h.

## ◆ RETURN_SIZED_ENUMERATOR

#define RETURN_SIZED_ENUMERATOR | ( |  | obj,
|  |  | argc,
|  |  | argv,
|  |  | size_fn
| ) |  |

Value:
do { \
if (!rb_block_given_p()) \
return SIZED_ENUMERATOR(obj, argc, argv, size_fn); \
} while (0)

Definition at line 271 of file intern.h.

## ◆ RETURN_SIZED_ENUMERATOR_KW

#define RETURN_SIZED_ENUMERATOR_KW | ( |  | obj,
|  |  | argc,
|  |  | argv,
|  |  | size_fn,
|  |  | kw_splat
| ) |  |

Value:
do { \
if (!rb_block_given_p()) \
return SIZED_ENUMERATOR_KW(obj, argc, argv, size_fn, kw_splat); \
} while (0)

Definition at line 275 of file intern.h.

## ◆ RUBY_UBF_IO

#define RUBY_UBF_IO ((rb_unblock_function_t *)-1)

Definition at line 945 of file intern.h.

## ◆ RUBY_UBF_PROCESS

#define RUBY_UBF_PROCESS ((rb_unblock_function_t *)-1)

Definition at line 946 of file intern.h.

## ◆ SIZED_ENUMERATOR

#define SIZED_ENUMERATOR | ( |  | obj,
|  |  | argc,
|  |  | argv,
|  |  | size_fn
| ) |  |

Value:
rb_enumeratorize_with_size((obj), ID2SYM(rb_frame_this_func()), \
(argc), (argv), (size_fn))

Definition at line 265 of file intern.h.

## ◆ SIZED_ENUMERATOR_KW

#define SIZED_ENUMERATOR_KW | ( |  | obj,
|  |  | argc,
|  |  | argv,
|  |  | size_fn,
|  |  | kw_splat
| ) |  |

Value:
rb_enumeratorize_with_size_kw((obj), ID2SYM(rb_frame_this_func()), \
(argc), (argv), (size_fn), (kw_splat))

Definition at line 268 of file intern.h.

## ◆ st_foreach_safe

#define st_foreach_safe rb_st_foreach_safe

Definition at line 556 of file intern.h.

## ◆ UNLIMITED_ARGUMENTS

#define UNLIMITED_ARGUMENTS (-1)

Definition at line 57 of file intern.h.

## Typedef Documentation

## ◆ rb_alloc_func_t

typedef VALUE(* rb_alloc_func_t) (VALUE)

Definition at line 427 of file intern.h.

## ◆ rb_blocking_function_t

typedef VALUE rb_blocking_function_t(void *)

Definition at line 941 of file intern.h.

## ◆ rb_enumerator_size_func

typedef VALUE rb_enumerator_size_func(VALUE, VALUE, VALUE)

Definition at line 256 of file intern.h.

## ◆ rb_fdset_t

typedef fd_set rb_fdset_t

Definition at line 403 of file intern.h.

## ◆ rb_hash_update_func

typedef VALUE rb_hash_update_func(VALUE newkey, VALUE oldkey, VALUE value)

Definition at line 573 of file intern.h.

## ◆ rb_unblock_function_t

typedef void rb_unblock_function_t(void *)

Definition at line 940 of file intern.h.

## Function Documentation

## ◆ CONSTFUNC() [1/2]

CONSTFUNC | ( | int | rb_is_const_idID | ) |

## ◆ CONSTFUNC() [2/2]

CONSTFUNC | ( | VALUE | rb_dbl_cmpdouble, double | ) |

## ◆ DEPRECATED_BY()

DEPRECATED_BY | ( | rb_complex_new_polar | ,
|  | VALUE | rb_complex_polarVALUE abs, VALUE arg
| ) |  |

## ◆ NORETURN() [1/9]

NORETURN | ( | MJIT_STATIC void | rb_error_arityint, int, int | ) |

## ◆ NORETURN() [2/9]

NORETURN | ( | VALUE | rb_f_exitint, const VALUE * | ) |

## ◆ NORETURN() [3/9]

NORETURN | ( | VALUE | rb_f_notimplementint argc, const VALUE *argv, VALUE obj, VALUE marker | ) |

## ◆ NORETURN() [4/9]

NORETURN | ( | void | rb_cmperrVALUE, VALUE | ) |

## ◆ NORETURN() [5/9]

NORETURN | ( | void | rb_error_frozenconst char * | ) |

## ◆ NORETURN() [6/9]

NORETURN | ( | void | rb_error_frozen_objectVALUE | ) |

## ◆ NORETURN() [7/9]

NORETURN | ( | void | rb_interruptvoid | ) |

## ◆ NORETURN() [8/9]

NORETURN | ( | void | rb_invalid_strconst char *, const char * | ) |

## ◆ NORETURN() [9/9]

NORETURN | ( | void | rb_jump_tagint | ) |

## ◆ PRINTF_ARGS() [1/7]

PRINTF_ARGS | ( | NORETURN(void rb_frozen_error_raise(VALUE, const char *,...)) | ,
|  | 2 | ,
|  | 3 |
| ) |  |

## ◆ PRINTF_ARGS() [2/7]

PRINTF_ARGS | ( | NORETURN(void rb_loaderror(const char *,...)) | ,
|  | 1 | ,
|  | 2 |
| ) |  |

## ◆ PRINTF_ARGS() [3/7]

PRINTF_ARGS | ( | NORETURN(void rb_loaderror_with_path(VALUE path, const char *,...)) | ,
|  | 2 | ,
|  | 3 |
| ) |  |

## ◆ PRINTF_ARGS() [4/7]

PRINTF_ARGS | ( | NORETURN(void rb_name_error(ID, const char *,...)) | ,
|  | 2 | ,
|  | 3 |
| ) |  |

## ◆ PRINTF_ARGS() [5/7]

PRINTF_ARGS | ( | NORETURN(void rb_name_error_str(VALUE, const char *,...)) | ,
|  | 2 | ,
|  | 3 |
| ) |  |

## ◆ PRINTF_ARGS() [6/7]

PRINTF_ARGS | ( | VALUE | rb_sprintfconst char *,...,
|  | 1 | ,
|  | 2 |
| ) |  |

## ◆ PRINTF_ARGS() [7/7]

PRINTF_ARGS | ( | VALUE | rb_str_catfVALUE, const char *,...,
|  | 2 | ,
|  | 3 |
| ) |  |

## ◆ PUREFUNC() [1/4]

PUREFUNC | ( | int | rb_during_gcvoid | ) |

## ◆ PUREFUNC() [2/4]

PUREFUNC | ( | size_t | rb_str_capacityVALUE | ) |

## ◆ PUREFUNC() [3/4]

PUREFUNC | ( | VALUE | rb_class_inherited_pVALUE, VALUE | ) |

## ◆ PUREFUNC() [4/4]

PUREFUNC | ( | VALUE | rb_obj_taintedVALUE | ) |

## ◆ rb_absint_numwords()

size_t rb_absint_numwords | ( | VALUE | val,
|  | size_t | word_numbits,
|  | size_t * | nlz_bits_ret
| ) |  |

Definition at line 3382 of file bignum.c.

## ◆ rb_absint_singlebit_p()

int rb_absint_singlebit_p | ( | VALUE | val | ) |

Definition at line 3446 of file bignum.c.

## ◆ rb_absint_size()

size_t rb_absint_size | ( | VALUE | val,
|  | int * | nlz_bits_ret
| ) |  |

Definition at line 3247 of file bignum.c.

## ◆ rb_alias()

void rb_alias | ( | VALUE | ,
|  | ID | ,
|  | ID |
| ) |  |

Definition at line 1581 of file vm_method.c.

Referenced by rb_define_alias().

## ◆ rb_alias_variable()

void rb_alias_variable | ( | ID | ,
|  | ID |
| ) |  |

Definition at line 756 of file variable.c.

## ◆ rb_apply()

VALUE rb_apply | ( | VALUE | recv,
|  | ID | mid,
|  | VALUE | args
| ) |  |

Calls a method.

Parameters

  recv | receiver of the method
  mid | an ID that represents the name of the method
  args | an Array object which contains method arguments

Precondition
  args must refer an Array object.

Definition at line 890 of file vm_eval.c.

## ◆ rb_arithmetic_sequence_extract()

int rb_arithmetic_sequence_extract | ( | VALUE | ,
|  | rb_arithmetic_sequence_components_t * |
| ) |  |

Definition at line 3374 of file enumerator.c.

## ◆ rb_ary_aref()

VALUE rb_ary_aref | ( | int | ,
|  | const VALUE * | ,
|  | VALUE |
| ) |  |

Definition at line 1574 of file array.c.

## ◆ rb_ary_assoc()

VALUE rb_ary_assoc | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 4156 of file array.c.

## ◆ rb_ary_cat()

VALUE rb_ary_cat | ( | VALUE | ,
|  | const VALUE * | ,
|  | long |
| ) |  |

Definition at line 1208 of file array.c.

## ◆ rb_ary_clear()

VALUE rb_ary_clear | ( | VALUE |  | ) |

Definition at line 3862 of file array.c.

## ◆ rb_ary_cmp()

VALUE rb_ary_cmp | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 4420 of file array.c.

## ◆ rb_ary_concat()

VALUE rb_ary_concat | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 4069 of file array.c.

## ◆ rb_ary_delete()

VALUE rb_ary_delete | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 3365 of file array.c.

## ◆ rb_ary_delete_at()

VALUE rb_ary_delete_at | ( | VALUE | ,
|  | long |
| ) |  |

Definition at line 3419 of file array.c.

## ◆ rb_ary_dup()

VALUE rb_ary_dup | ( | VALUE |  | ) |

Definition at line 2238 of file array.c.

## ◆ rb_ary_each()

VALUE rb_ary_each | ( | VALUE |  | ) |

Definition at line 2129 of file array.c.

## ◆ rb_ary_entry()

VALUE rb_ary_entry | ( | VALUE | ,
|  | long |
| ) |  |

Definition at line 1512 of file array.c.

## ◆ rb_ary_free()

void rb_ary_free | ( | VALUE |  | ) |

Definition at line 786 of file array.c.

## ◆ rb_ary_freeze()

VALUE rb_ary_freeze | ( | VALUE |  | ) |

Definition at line 648 of file array.c.

## ◆ rb_ary_includes()

VALUE rb_ary_includes | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 4340 of file array.c.

## ◆ rb_ary_join()

VALUE rb_ary_join | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 2347 of file array.c.

## ◆ rb_ary_modify()

void rb_ary_modify | ( | VALUE |  | ) |

Definition at line 548 of file array.c.

## ◆ rb_ary_new()

VALUE rb_ary_new | ( | void |  | ) |

Definition at line 723 of file array.c.

## ◆ rb_ary_new_capa()

VALUE rb_ary_new_capa | ( | long | capa | ) |

Definition at line 717 of file array.c.

## ◆ rb_ary_new_from_args()

VALUE rb_ary_new_from_args | ( | long | n,
|  |  | ...
| ) |  |

Definition at line 729 of file array.c.

## ◆ rb_ary_new_from_values()

VALUE rb_ary_new_from_values | ( | long | n,
|  | const VALUE * | elts
| ) |  |

Definition at line 762 of file array.c.

## ◆ rb_ary_plus()

VALUE rb_ary_plus | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 4000 of file array.c.

## ◆ rb_ary_pop()

VALUE rb_ary_pop | ( | VALUE |  | ) |

Definition at line 1241 of file array.c.

## ◆ rb_ary_push()

VALUE rb_ary_push | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1195 of file array.c.

## ◆ rb_ary_rassoc()

VALUE rb_ary_rassoc | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 4189 of file array.c.

## ◆ rb_ary_replace()

VALUE rb_ary_replace | ( | VALUE | copy,
|  | VALUE | orig
| ) |  |

Definition at line 3811 of file array.c.

## ◆ rb_ary_resize()

VALUE rb_ary_resize | ( | VALUE | ary,
|  | long | len
| ) |  |

expands or shrinks ary to len elements.

expanded region will be filled with Qnil.

Parameters

  ary | an array
  len | new size

Returns
  ary

Postcondition
  the size of ary is len.

Definition at line 1955 of file array.c.

## ◆ rb_ary_resurrect()

VALUE rb_ary_resurrect | ( | VALUE | ary | ) |

Definition at line 2251 of file array.c.

## ◆ rb_ary_reverse()

VALUE rb_ary_reverse | ( | VALUE |  | ) |

Definition at line 2544 of file array.c.

## ◆ rb_ary_rotate()

VALUE rb_ary_rotate | ( | VALUE | ,
|  | long |
| ) |  |

Definition at line 2617 of file array.c.

## ◆ rb_ary_shared_with_p()

VALUE rb_ary_shared_with_p | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 661 of file array.c.

## ◆ rb_ary_shift()

VALUE rb_ary_shift | ( | VALUE |  | ) |

Definition at line 1294 of file array.c.

## ◆ rb_ary_sort()

VALUE rb_ary_sort | ( | VALUE |  | ) |

Definition at line 2866 of file array.c.

## ◆ rb_ary_sort_bang()

VALUE rb_ary_sort_bang | ( | VALUE |  | ) |

Definition at line 2777 of file array.c.

## ◆ rb_ary_store()

void rb_ary_store | ( | VALUE | ,
|  | long | ,
|  | VALUE |
| ) |  |

Definition at line 1079 of file array.c.

## ◆ rb_ary_subseq()

VALUE rb_ary_subseq | ( | VALUE | ,
|  | long | ,
|  | long |
| ) |  |

Definition at line 1518 of file array.c.

## ◆ rb_ary_tmp_new()

VALUE rb_ary_tmp_new | ( | long |  | ) |

Definition at line 768 of file array.c.

## ◆ rb_ary_to_ary()

VALUE rb_ary_to_ary | ( | VALUE |  | ) |

Definition at line 1853 of file array.c.

## ◆ rb_ary_to_s()

VALUE rb_ary_to_s | ( | VALUE |  | ) |

Definition at line 2453 of file array.c.

## ◆ rb_ary_unshift()

VALUE rb_ary_unshift | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1494 of file array.c.

## ◆ rb_assoc_new()

VALUE rb_assoc_new | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 896 of file array.c.

## ◆ rb_attr()

void rb_attr | ( | VALUE | ,
|  | ID | ,
|  | int | ,
|  | int | ,
|  | int |
| ) |  |

Definition at line 1163 of file vm_method.c.

Referenced by rb_define_attr().

## ◆ rb_attr_get()

VALUE rb_attr_get | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 1084 of file variable.c.

Referenced by rb_dtrace_setup(), and rb_singleton_class_internal_p().

## ◆ rb_autoload_load()

VALUE rb_autoload_load | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 2222 of file variable.c.

## ◆ rb_autoload_p()

VALUE rb_autoload_p | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 2281 of file variable.c.

## ◆ rb_backref_get()

VALUE rb_backref_get | ( | void |  | ) |

Definition at line 1304 of file vm.c.

Referenced by rb_f_global_variables().

## ◆ rb_backref_set()

void rb_backref_set | ( | VALUE |  | ) |

Definition at line 1310 of file vm.c.

Referenced by rb_reg_match2().

## ◆ rb_backtrace()

void rb_backtrace | ( | void |  | ) |

Definition at line 829 of file vm_backtrace.c.

## ◆ rb_big2dbl()

double rb_big2dbl | ( | VALUE |  | ) |

Definition at line 5310 of file bignum.c.

## ◆ rb_big2long()

long rb_big2long | ( | VALUE |  | ) |

Definition at line 5140 of file bignum.c.

## ◆ rb_big2str()

VALUE rb_big2str | ( | VALUE | ,
|  | int |
| ) |  |

Definition at line 5091 of file bignum.c.

## ◆ rb_big2ulong()

unsigned long rb_big2ulong | ( | VALUE |  | ) |

Definition at line 5125 of file bignum.c.

## ◆ rb_big_2comp()

void rb_big_2comp | ( | VALUE |  | ) |

Definition at line 3049 of file bignum.c.

## ◆ rb_big_and()

VALUE rb_big_and | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 6360 of file bignum.c.

## ◆ rb_big_clone()

VALUE rb_big_clone | ( | VALUE |  | ) |

Definition at line 3020 of file bignum.c.

## ◆ rb_big_cmp()

VALUE rb_big_cmp | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 5419 of file bignum.c.

## ◆ rb_big_div()

VALUE rb_big_div | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 6091 of file bignum.c.

## ◆ rb_big_divmod()

VALUE rb_big_divmod | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 6135 of file bignum.c.

## ◆ rb_big_eq()

VALUE rb_big_eq | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 5524 of file bignum.c.

## ◆ rb_big_eql()

VALUE rb_big_eql | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 5544 of file bignum.c.

## ◆ rb_big_idiv()

VALUE rb_big_idiv | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 6097 of file bignum.c.

## ◆ rb_big_lshift()

VALUE rb_big_lshift | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 6621 of file bignum.c.

## ◆ rb_big_minus()

VALUE rb_big_minus | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 5853 of file bignum.c.

## ◆ rb_big_modulo()

VALUE rb_big_modulo | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 6103 of file bignum.c.

## ◆ rb_big_mul()

VALUE rb_big_mul | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 5933 of file bignum.c.

## ◆ rb_big_new()

VALUE rb_big_new | ( | size_t | ,
|  | int |
| ) |  |

Definition at line 3014 of file bignum.c.

## ◆ rb_big_norm()

VALUE rb_big_norm | ( | VALUE |  | ) |

Definition at line 3152 of file bignum.c.

## ◆ rb_big_or()

VALUE rb_big_or | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 6479 of file bignum.c.

## ◆ rb_big_pack()

void rb_big_pack | ( | VALUE | val,
|  | unsigned long * | buf,
|  | long | num_longs
| ) |  |

Definition at line 3215 of file bignum.c.

## ◆ rb_big_plus()

VALUE rb_big_plus | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 5824 of file bignum.c.

## ◆ rb_big_pow()

VALUE rb_big_pow | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 6244 of file bignum.c.

## ◆ rb_big_resize()

void rb_big_resize | ( | VALUE | big,
|  | size_t | len
| ) |  |

Definition at line 2989 of file bignum.c.

## ◆ rb_big_rshift()

VALUE rb_big_rshift | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 6651 of file bignum.c.

## ◆ rb_big_unpack()

VALUE rb_big_unpack | ( | unsigned long * | buf,
|  | long | num_longs
| ) |  |

Definition at line 3223 of file bignum.c.

## ◆ rb_big_xor()

VALUE rb_big_xor | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 6573 of file bignum.c.

## ◆ rb_bigzero_p()

int rb_bigzero_p | ( | VALUE | x | ) |

Definition at line 2919 of file bignum.c.

## ◆ rb_binding_new()

VALUE rb_binding_new | ( | void |  | ) |

Definition at line 364 of file proc.c.

## ◆ rb_block_lambda()

VALUE rb_block_lambda | ( | void |  | ) |

Definition at line 856 of file proc.c.

## ◆ rb_block_proc()

VALUE rb_block_proc | ( | void |  | ) |

Definition at line 837 of file proc.c.

Referenced by rb_f_trace_var().

## ◆ rb_check_array_type()

VALUE rb_check_array_type | ( | VALUE |  | ) |

Definition at line 909 of file array.c.

## ◆ rb_check_funcall()

VALUE rb_check_funcall | ( | VALUE | ,
|  | ID | ,
|  | int | ,
|  | const VALUE * |
| ) |  |

Definition at line 505 of file vm_eval.c.

Referenced by rb_get_message(), rb_iseq_load_iseq(), and rb_range_values().

## ◆ rb_check_funcall_kw()

VALUE rb_check_funcall_kw | ( | VALUE | ,
|  | ID | ,
|  | int | ,
|  | const VALUE * | ,
|  | int |
| ) |  |

Definition at line 499 of file vm_eval.c.

## ◆ rb_check_hash_type()

VALUE rb_check_hash_type | ( | VALUE |  | ) |

Definition at line 1825 of file hash.c.

## ◆ rb_check_string_type()

VALUE rb_check_string_type | ( | VALUE |  | ) |

Definition at line 2314 of file string.c.

Referenced by rb_check_id(), rb_String(), and rb_time_zone_abbreviation().

## ◆ rb_class_name()

VALUE rb_class_name | ( | VALUE |  | ) |

Definition at line 274 of file variable.c.

Referenced by rb_any_to_s().

## ◆ rb_class_path()

VALUE rb_class_path | ( | VALUE |  | ) |

Definition at line 153 of file variable.c.

Referenced by rb_define_class_id_under(), and rb_dtrace_setup().

## ◆ rb_class_path_cached()

VALUE rb_class_path_cached | ( | VALUE |  | ) |

Definition at line 162 of file variable.c.

## ◆ rb_clear_constant_cache()

void rb_clear_constant_cache | ( | void |  | ) |

Definition at line 87 of file vm_method.c.

## ◆ rb_clear_method_cache_by_class()

void rb_clear_method_cache_by_class | ( | VALUE |  | ) |

Definition at line 93 of file vm_method.c.

## ◆ rb_cloexec_dup()

int rb_cloexec_dup | ( | int | oldfd | ) |

Definition at line 318 of file io.c.

## ◆ rb_cloexec_dup2()

int rb_cloexec_dup2 | ( | int | oldfd,
|  | int | newfd
| ) |  |

Definition at line 325 of file io.c.

## ◆ rb_cloexec_fcntl_dupfd()

int rb_cloexec_fcntl_dupfd | ( | int | fd,
|  | int | minfd
| ) |  |

Definition at line 419 of file io.c.

## ◆ rb_cloexec_open()

int rb_cloexec_open | ( | const char * | pathname,
|  | int | flags,
|  | mode_t | mode
| ) |  |

Definition at line 292 of file io.c.

Referenced by rb_file_load_ok().

## ◆ rb_cloexec_pipe()

int rb_cloexec_pipe | ( | int | fildes[2] | ) |

Definition at line 378 of file io.c.

## ◆ rb_close_before_exec()

void rb_close_before_exec | ( | int | lowfd,
|  | int | maxhint,
|  | VALUE | noclose_fds
| ) |  |

## ◆ rb_cmpint()

int rb_cmpint | ( | VALUE | ,
|  | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 2925 of file bignum.c.

## ◆ rb_Complex()

VALUE rb_Complex | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1545 of file complex.c.

## ◆ rb_complex_abs()

VALUE rb_complex_abs | ( | VALUE | z | ) |

Definition at line 1161 of file complex.c.

## ◆ rb_complex_arg()

VALUE rb_complex_arg | ( | VALUE | z | ) |

Definition at line 1208 of file complex.c.

## ◆ rb_complex_conjugate()

VALUE rb_complex_conjugate | ( | VALUE | z | ) |

Definition at line 1254 of file complex.c.

## ◆ rb_complex_div()

VALUE rb_complex_div | ( | VALUE | x,
|  | VALUE | y
| ) |  |

Definition at line 948 of file complex.c.

## ◆ rb_complex_imag()

VALUE rb_complex_imag | ( | VALUE | z | ) |

Definition at line 743 of file complex.c.

## ◆ rb_complex_minus()

VALUE rb_complex_minus | ( | VALUE | x,
|  | VALUE | y
| ) |  |

Definition at line 812 of file complex.c.

## ◆ rb_complex_mul()

VALUE rb_complex_mul | ( | VALUE | x,
|  | VALUE | y
| ) |  |

Definition at line 872 of file complex.c.

## ◆ rb_complex_new()

VALUE rb_complex_new | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1527 of file complex.c.

## ◆ rb_complex_new_polar()

VALUE rb_complex_new_polar | ( | VALUE | abs,
|  | VALUE | arg
| ) |  |

Definition at line 1533 of file complex.c.

## ◆ rb_complex_plus()

VALUE rb_complex_plus | ( | VALUE | x,
|  | VALUE | y
| ) |  |

Definition at line 778 of file complex.c.

## ◆ rb_complex_pow()

VALUE rb_complex_pow | ( | VALUE | base,
|  | VALUE | exp
| ) |  |

Definition at line 985 of file complex.c.

## ◆ rb_complex_raw()

VALUE rb_complex_raw | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1521 of file complex.c.

## ◆ rb_complex_real()

VALUE rb_complex_real | ( | VALUE | z | ) |

Definition at line 726 of file complex.c.

## ◆ rb_complex_uminus()

VALUE rb_complex_uminus | ( | VALUE | z | ) |

Definition at line 758 of file complex.c.

## ◆ rb_const_defined()

int rb_const_defined | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 2682 of file variable.c.

Referenced by Init_cparse(), rb_define_class(), and rb_define_module().

## ◆ rb_const_defined_at()

int rb_const_defined_at | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 2688 of file variable.c.

Referenced by rb_define_class_id_under(), and rb_define_module_id_under().

## ◆ rb_const_defined_from()

int rb_const_defined_from | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 2676 of file variable.c.

## ◆ rb_const_get()

VALUE rb_const_get | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 2387 of file variable.c.

Referenced by generic_to_value(), Init_cparse(), Init_objspace(), rb_define_class(), and rb_define_module().

## ◆ rb_const_get_at()

VALUE rb_const_get_at | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 2393 of file variable.c.

Referenced by Init_cparse(), rb_define_class_id_under(), and rb_define_module_id_under().

## ◆ rb_const_get_from()

VALUE rb_const_get_from | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 2381 of file variable.c.

## ◆ rb_const_list()

VALUE rb_const_list | ( | void * |  | ) |

Definition at line 2594 of file variable.c.

## ◆ rb_const_remove()

VALUE rb_const_remove | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 2490 of file variable.c.

## ◆ rb_const_set()

void rb_const_set | ( | VALUE | ,
|  | ID | ,
|  | VALUE |
| ) |  |

Definition at line 2752 of file variable.c.

Referenced by rb_define_class(), rb_define_class_id_under(), rb_define_module(), and rb_define_module_id_under().

## ◆ rb_copy_generic_ivar()

void rb_copy_generic_ivar | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1447 of file variable.c.

## ◆ rb_cstr2inum()

VALUE rb_cstr2inum | ( | const char * | ,
|  | int |
| ) |  |

Definition at line 4538 of file bignum.c.

## ◆ rb_cstr_to_inum()

VALUE rb_cstr_to_inum | ( | const char * | ,
|  | int | ,
|  | int |
| ) |  |

Definition at line 4012 of file bignum.c.

## ◆ rb_cv_get()

VALUE rb_cv_get | ( | VALUE | ,
|  | const char * |
| ) |  |

Definition at line 3138 of file variable.c.

## ◆ rb_cv_set()

void rb_cv_set | ( | VALUE | ,
|  | const char * | ,
|  | VALUE |
| ) |  |

Definition at line 3131 of file variable.c.

## ◆ rb_cvar_defined()

VALUE rb_cvar_defined | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 3112 of file variable.c.

## ◆ rb_cvar_get()

VALUE rb_cvar_get | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 3096 of file variable.c.

## ◆ rb_cvar_set()

void rb_cvar_set | ( | VALUE | ,
|  | ID | ,
|  | VALUE |
| ) |  |

Definition at line 3074 of file variable.c.

## ◆ rb_dbl2big()

VALUE rb_dbl2big | ( | double |  | ) |

Definition at line 5249 of file bignum.c.

## ◆ rb_dbl_complex_new()

VALUE rb_dbl_complex_new | ( | double | real,
|  | double | imag
| ) |  |

Creates a Complex object.

Parameters

  real | real part value
  imag | imaginary part value

Returns
  a new Complex object

Definition at line 1561 of file complex.c.

## ◆ rb_define_alloc_func()

void rb_define_alloc_func | ( | VALUE | ,
|  | rb_alloc_func_t |
| ) |  |

Referenced by Init_Array(), Init_Dir(), Init_Encoding(), Init_fiddle_closure(), Init_fiddle_function(), Init_fiddle_handle(), Init_monitor(), Init_ossl_bn(), Init_ossl_cipher(), Init_ossl_digest(), Init_ossl_hmac(), Init_ossl_ns_spki(), Init_ossl_ocsp(), Init_ossl_x509attr(), Init_ossl_x509cert(), Init_ossl_x509crl(), Init_ossl_x509ext(), Init_ossl_x509req(), Init_ossl_x509revoked(), Init_psych_emitter(), Init_psych_parser(), Init_stringio(), Init_win32ole_method(), Init_win32ole_param(), Init_win32ole_record(), and Init_win32ole_variant().

## ◆ rb_define_class_variable()

void rb_define_class_variable | ( | VALUE | ,
|  | const char * | ,
|  | VALUE |
| ) |  |

Definition at line 3145 of file variable.c.

## ◆ rb_define_finalizer()

VALUE rb_define_finalizer | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 3287 of file gc.c.

## ◆ rb_detach_process()

VALUE rb_detach_process | ( | rb_pid_t | pid | ) |

Definition at line 1423 of file process.c.

References ruby::backward::cxxanyargs::rb_thread_create().

## ◆ rb_dir_getwd()

VALUE rb_dir_getwd | ( | void |  | ) |

Definition at line 1141 of file dir.c.

## ◆ rb_enum_values_pack()

VALUE rb_enum_values_pack | ( | int | ,
|  | const VALUE * |
| ) |  |

Definition at line 33 of file enum.c.

## ◆ rb_enumeratorize()

VALUE rb_enumeratorize | ( | VALUE | ,
|  | VALUE | ,
|  | int | ,
|  | const VALUE * |
| ) |  |

Definition at line 516 of file enumerator.c.

## ◆ rb_enumeratorize_with_size()

VALUE rb_enumeratorize_with_size | ( | VALUE | ,
|  | VALUE | ,
|  | int | ,
|  | const VALUE * | ,
|  | rb_enumerator_size_func * |
| ) |  |

Definition at line 525 of file enumerator.c.

## ◆ rb_enumeratorize_with_size_kw()

VALUE rb_enumeratorize_with_size_kw | ( | VALUE | ,
|  | VALUE | ,
|  | int | ,
|  | const VALUE * | ,
|  | rb_enumerator_size_func * | ,
|  | int |
| ) |  |

Definition at line 537 of file enumerator.c.

## ◆ rb_env_clear()

VALUE rb_env_clear | ( | void |  | ) |

Definition at line 5553 of file hash.c.

## ◆ rb_env_path_tainted()

int rb_env_path_tainted | ( | void |  | ) |

Definition at line 4829 of file hash.c.

## ◆ rb_eval_cmd()

VALUE rb_eval_cmd | ( | VALUE | ,
|  | VALUE | ,
|  | int |
| ) |  |

Definition at line 1822 of file vm_eval.c.

## ◆ rb_eval_cmd_kw()

VALUE rb_eval_cmd_kw | ( | VALUE | ,
|  | VALUE | ,
|  | int |
| ) |  |

Definition at line 1799 of file vm_eval.c.

## ◆ rb_exec_recursive()

VALUE rb_exec_recursive | ( | VALUE(*)(VALUE, VALUE, int) | ,
|  | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 5075 of file thread.c.

Referenced by rb_invcmp(), and rb_io_puts().

## ◆ rb_exec_recursive_outer()

VALUE rb_exec_recursive_outer | ( | VALUE(*)(VALUE, VALUE, int) | ,
|  | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 5098 of file thread.c.

Referenced by rb_hash().

## ◆ rb_exec_recursive_paired()

VALUE rb_exec_recursive_paired | ( | VALUE(*)(VALUE, VALUE, int) | ,
|  | VALUE | ,
|  | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 5086 of file thread.c.

Referenced by rb_ary_cmp().

## ◆ rb_exec_recursive_paired_outer()

VALUE rb_exec_recursive_paired_outer | ( | VALUE(*)(VALUE, VALUE, int) | ,
|  | VALUE | ,
|  | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 5110 of file thread.c.

## ◆ rb_external_str_new()

VALUE rb_external_str_new | ( | const char * | ,
|  | long |
| ) |  |

Definition at line 1087 of file string.c.

## ◆ rb_external_str_new_cstr()

VALUE rb_external_str_new_cstr | ( | const char * |  | ) |

Definition at line 1093 of file string.c.

## ◆ rb_f_global_variables()

VALUE rb_f_global_variables | ( | void |  | ) |

Definition at line 728 of file variable.c.

## ◆ rb_f_kill()

VALUE rb_f_kill | ( | int | ,
|  | const VALUE * |
| ) |  |

Definition at line 418 of file signal.c.

## ◆ rb_f_require()

VALUE rb_f_require | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 809 of file load.c.

## ◆ rb_f_sprintf()

VALUE rb_f_sprintf | ( | int | ,
|  | const VALUE * |
| ) |  |

Definition at line 198 of file sprintf.c.

Referenced by rb_io_printf().

## ◆ rb_f_trace_var()

VALUE rb_f_trace_var | ( | int | ,
|  | const VALUE * |
| ) |  |

Definition at line 528 of file variable.c.

## ◆ rb_f_untrace_var()

VALUE rb_f_untrace_var | ( | int | ,
|  | const VALUE * |
| ) |  |

Definition at line 574 of file variable.c.

## ◆ rb_fd_fix_cloexec()

void rb_fd_fix_cloexec | ( | int | fd | ) |

Definition at line 268 of file io.c.

## ◆ rb_feature_provided()

int rb_feature_provided | ( | const char * | ,
|  | const char ** |
| ) |  |

Definition at line 519 of file load.c.

## ◆ rb_fiber_alive_p()

VALUE rb_fiber_alive_p | ( | VALUE |  | ) |

Definition at line 2137 of file cont.c.

## ◆ rb_fiber_current()

VALUE rb_fiber_current | ( | void |  | ) |

Definition at line 1942 of file cont.c.

## ◆ rb_fiber_new()

VALUE rb_fiber_new | ( | rb_block_call_func_t | ,
|  | VALUE |
| ) |  |

Definition at line 1780 of file cont.c.

## ◆ rb_fiber_resume()

VALUE rb_fiber_resume | ( | VALUE | fib,
|  | int | argc,
|  | const VALUE * | argv
| ) |  |

Definition at line 2102 of file cont.c.

## ◆ rb_fiber_resume_kw()

VALUE rb_fiber_resume_kw | ( | VALUE | fib,
|  | int | argc,
|  | const VALUE * | argv,
|  | int | kw_splat
| ) |  |

Definition at line 2082 of file cont.c.

## ◆ rb_fiber_yield()

VALUE rb_fiber_yield | ( | int | argc,
|  | const VALUE * | argv
| ) |  |

Definition at line 2114 of file cont.c.

## ◆ rb_fiber_yield_kw()

VALUE rb_fiber_yield_kw | ( | int | argc,
|  | const VALUE * | argv,
|  | int | kw_splat
| ) |  |

Definition at line 2108 of file cont.c.

## ◆ rb_file_absolute_path()

VALUE rb_file_absolute_path | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 4072 of file file.c.

## ◆ rb_file_directory_p()

VALUE rb_file_directory_p | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1577 of file file.c.

## ◆ rb_file_dirname()

VALUE rb_file_dirname | ( | VALUE | fname | ) |

Definition at line 4645 of file file.c.

## ◆ rb_file_expand_path()

VALUE rb_file_expand_path | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 4018 of file file.c.

## ◆ rb_file_open()

VALUE rb_file_open | ( | const char * | ,
|  | const char * |
| ) |  |

Definition at line 6259 of file io.c.

## ◆ rb_file_open_str()

VALUE rb_file_open_str | ( | VALUE | ,
|  | const char * |
| ) |  |

Definition at line 6252 of file io.c.

## ◆ rb_file_s_absolute_path()

VALUE rb_file_s_absolute_path | ( | int | ,
|  | const VALUE * |
| ) |  |

Definition at line 4079 of file file.c.

## ◆ rb_file_s_expand_path()

VALUE rb_file_s_expand_path | ( | int | ,
|  | const VALUE * |
| ) |  |

Definition at line 4031 of file file.c.

## ◆ rb_filesystem_str_new()

VALUE rb_filesystem_str_new | ( | const char * | ,
|  | long |
| ) |  |

Definition at line 1111 of file string.c.

## ◆ rb_filesystem_str_new_cstr()

VALUE rb_filesystem_str_new_cstr | ( | const char * |  | ) |

Definition at line 1117 of file string.c.

Referenced by rb_parser_compile_string().

## ◆ rb_find_file()

VALUE rb_find_file | ( | VALUE |  | ) |

Definition at line 6336 of file file.c.

## ◆ rb_find_file_ext()

int rb_find_file_ext | ( | VALUE * | ,
|  | const char *const * |
| ) |  |

Definition at line 6270 of file file.c.

## ◆ rb_find_file_ext_safe()

int rb_find_file_ext_safe | ( | VALUE * | ,
|  | const char *const * | ,
|  | int |
| ) |  |

Definition at line 6263 of file file.c.

## ◆ rb_find_file_safe()

VALUE rb_find_file_safe | ( | VALUE | ,
|  | int |
| ) |  |

Definition at line 6329 of file file.c.

## ◆ rb_fix2str()

VALUE rb_fix2str | ( | VALUE | ,
|  | int |
| ) |  |

Definition at line 3508 of file numeric.c.

## ◆ rb_flt_rationalize()

VALUE rb_flt_rationalize | ( | VALUE |  | ) |

Definition at line 2242 of file rational.c.

## ◆ rb_flt_rationalize_with_prec()

VALUE rb_flt_rationalize_with_prec | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 2226 of file rational.c.

## ◆ rb_frame_method_id_and_class()

int rb_frame_method_id_and_class | ( | ID * | idp,
|  | VALUE * | klassp
| ) |  |

Definition at line 2206 of file vm.c.

## ◆ rb_free_generic_ivar()

void rb_free_generic_ivar | ( | VALUE |  | ) |

Definition at line 993 of file variable.c.

## ◆ rb_gc()

void rb_gc | ( | void |  | ) |

Definition at line 8679 of file gc.c.

## ◆ rb_gc_adjust_memory_usage()

void rb_gc_adjust_memory_usage | ( | ssize_t |  | ) |

Definition at line 10300 of file gc.c.

## ◆ rb_gc_copy_finalizer()

void rb_gc_copy_finalizer | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 3295 of file gc.c.

## ◆ rb_gc_count()

size_t rb_gc_count | ( | void |  | ) |

Definition at line 8711 of file gc.c.

## ◆ rb_gc_disable()

VALUE rb_gc_disable | ( | void |  | ) |

Definition at line 9235 of file gc.c.

## ◆ rb_gc_enable()

VALUE rb_gc_enable | ( | void |  | ) |

Definition at line 9209 of file gc.c.

## ◆ rb_gc_force_recycle()

void rb_gc_force_recycle | ( | VALUE |  | ) |

Definition at line 7011 of file gc.c.

## ◆ rb_gc_latest_gc_info()

VALUE rb_gc_latest_gc_info | ( | VALUE |  | ) |

Definition at line 8816 of file gc.c.

## ◆ rb_gc_location()

VALUE rb_gc_location | ( | VALUE |  | ) |

Definition at line 8111 of file gc.c.

## ◆ rb_gc_mark()

void rb_gc_mark | ( | VALUE |  | ) |

Definition at line 5212 of file gc.c.

## ◆ rb_gc_mark_locations()

void rb_gc_mark_locations | ( | const VALUE * | ,
|  | const VALUE * |
| ) |  |

Definition at line 4699 of file gc.c.

## ◆ rb_gc_mark_maybe()

void rb_gc_mark_maybe | ( | VALUE |  | ) |

Definition at line 5044 of file gc.c.

## ◆ rb_gc_mark_movable()

void rb_gc_mark_movable | ( | VALUE |  | ) |

Definition at line 5206 of file gc.c.

## ◆ rb_gc_start()

VALUE rb_gc_start | ( | void |  | ) |

Definition at line 8672 of file gc.c.

## ◆ rb_gc_stat()

size_t rb_gc_stat | ( | VALUE |  | ) |

Definition at line 9174 of file gc.c.

## ◆ rb_gc_update_tbl_refs()

void rb_gc_update_tbl_refs | ( | st_table * | ptr | ) |

Definition at line 7983 of file gc.c.

## ◆ rb_genrand_int32()

unsigned int rb_genrand_int32 | ( | void |  | ) |

Definition at line 115 of file random.c.

## ◆ rb_genrand_real()

double rb_genrand_real | ( | void |  | ) |

Definition at line 122 of file random.c.

## ◆ rb_genrand_ulong_limited()

unsigned long rb_genrand_ulong_limited | ( | unsigned long | i | ) |

Definition at line 807 of file random.c.

## ◆ rb_get_alloc_func()

rb_alloc_func_t rb_get_alloc_func | ( | VALUE |  | ) |

Definition at line 728 of file vm_method.c.

Referenced by rb_marshal_define_compat().

## ◆ rb_get_argv()

VALUE rb_get_argv | ( | void |  | ) |

Definition at line 12889 of file io.c.

## ◆ rb_get_values_at()

VALUE rb_get_values_at | ( | VALUE | ,
|  | long | ,
|  | int | ,
|  | const VALUE * | ,
|  | VALUE(*)(VALUE, long) |
| ) |  |

Definition at line 3106 of file array.c.

## ◆ rb_gets()

VALUE rb_gets | ( | void |  | ) |

Definition at line 8902 of file io.c.

## ◆ rb_hash()

VALUE rb_hash | ( | VALUE |  | ) |

Definition at line 129 of file hash.c.

## ◆ rb_hash_aref()

VALUE rb_hash_aref | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1964 of file hash.c.

## ◆ rb_hash_aset()

VALUE rb_hash_aset | ( | VALUE | ,
|  | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 2779 of file hash.c.

## ◆ rb_hash_bulk_insert()

void rb_hash_bulk_insert | ( | long | ,
|  | const VALUE * | ,
|  | VALUE |
| ) |  |

Definition at line 4515 of file hash.c.

## ◆ rb_hash_clear()

VALUE rb_hash_clear | ( | VALUE |  | ) |

Definition at line 2696 of file hash.c.

## ◆ rb_hash_delete()

VALUE rb_hash_delete | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 2271 of file hash.c.

## ◆ rb_hash_delete_if()

VALUE rb_hash_delete_if | ( | VALUE |  | ) |

Definition at line 2420 of file hash.c.

## ◆ rb_hash_dup()

VALUE rb_hash_dup | ( | VALUE |  | ) |

Definition at line 1537 of file hash.c.

## ◆ rb_hash_end()

st_index_t rb_hash_end | ( | st_index_t |  | ) |

## ◆ rb_hash_fetch()

VALUE rb_hash_fetch | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 2061 of file hash.c.

## ◆ rb_hash_foreach()

void rb_hash_foreach | ( | VALUE | ,
|  | int(*)(VALUE, VALUE, VALUE) | ,
|  | VALUE |
| ) |  |

## ◆ rb_hash_free()

void rb_hash_free | ( | VALUE |  | ) |

## ◆ rb_hash_freeze()

VALUE rb_hash_freeze | ( | VALUE |  | ) |

Definition at line 87 of file hash.c.

## ◆ rb_hash_lookup()

VALUE rb_hash_lookup | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1990 of file hash.c.

## ◆ rb_hash_lookup2()

VALUE rb_hash_lookup2 | ( | VALUE | ,
|  | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1977 of file hash.c.

## ◆ rb_hash_new()

VALUE rb_hash_new | ( | void |  | ) |

Definition at line 1501 of file hash.c.

## ◆ rb_hash_set_ifnone()

VALUE rb_hash_set_ifnone | ( | VALUE | hash,
|  | VALUE | ifnone
| ) |  |

Definition at line 99 of file hash.c.

## ◆ rb_hash_size()

VALUE rb_hash_size | ( | VALUE |  | ) |

Definition at line 2866 of file hash.c.

## ◆ rb_hash_start()

st_index_t rb_hash_start | ( | st_index_t |  | ) |

Definition at line 1434 of file random.c.

## ◆ rb_hash_tbl()

struct st_table* rb_hash_tbl | ( | VALUE | ,
|  | const char * | file,
|  | int | line
| ) |  |

Definition at line 1574 of file hash.c.

## ◆ rb_hash_uint()

st_index_t rb_hash_uint | ( | st_index_t | ,
|  | st_index_t |
| ) |  |

## ◆ rb_hash_uint32()

st_index_t rb_hash_uint32 | ( | st_index_t | ,
|  | uint32_t |
| ) |  |

## ◆ rb_hash_update_by()

VALUE rb_hash_update_by | ( | VALUE | hash1,
|  | VALUE | hash2,
|  | rb_hash_update_func * | func
| ) |  |

Definition at line 3835 of file hash.c.

## ◆ rb_id_attrset()

ID rb_id_attrset | ( | ID |  | ) |

Definition at line 98 of file symbol.c.

## ◆ rb_integer_pack()

int rb_integer_pack | ( | VALUE | val,
|  | void * | words,
|  | size_t | numwords,
|  | size_t | wordsize,
|  | size_t | nails,
|  | int | flags
| ) |  |

Definition at line 3547 of file bignum.c.

## ◆ rb_integer_unpack()

VALUE rb_integer_unpack | ( | const void * | words,
|  | size_t | numwords,
|  | size_t | wordsize,
|  | size_t | nails,
|  | int | flags
| ) |  |

Definition at line 3633 of file bignum.c.

## ◆ rb_io_addstr()

VALUE rb_io_addstr | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1843 of file io.c.

## ◆ rb_io_ascii8bit_binmode()

VALUE rb_io_ascii8bit_binmode | ( | VALUE |  | ) |

Definition at line 5380 of file io.c.

Referenced by rsock_init_sock().

## ◆ rb_io_binmode()

VALUE rb_io_binmode | ( | VALUE |  | ) |

Definition at line 5334 of file io.c.

## ◆ rb_io_close()

VALUE rb_io_close | ( | VALUE |  | ) |

Definition at line 4820 of file io.c.

## ◆ rb_io_eof()

VALUE rb_io_eof | ( | VALUE |  | ) |

Definition at line 2149 of file io.c.

## ◆ rb_io_fdopen()

VALUE rb_io_fdopen | ( | int | ,
|  | int | ,
|  | const char * |
| ) |  |

Definition at line 8004 of file io.c.

## ◆ rb_io_flush()

VALUE rb_io_flush | ( | VALUE |  | ) |

Definition at line 1903 of file io.c.

## ◆ rb_io_get_io()

VALUE rb_io_get_io | ( | VALUE |  | ) |

Definition at line 733 of file io.c.

## ◆ rb_io_getbyte()

VALUE rb_io_getbyte | ( | VALUE |  | ) |

Definition at line 4215 of file io.c.

## ◆ rb_io_gets()

VALUE rb_io_gets | ( | VALUE |  | ) |

Definition at line 3573 of file io.c.

## ◆ rb_io_print()

VALUE rb_io_print | ( | int | ,
|  | const VALUE * | ,
|  | VALUE |
| ) |  |

Definition at line 7576 of file io.c.

## ◆ rb_io_printf()

VALUE rb_io_printf | ( | int | ,
|  | const VALUE * | ,
|  | VALUE |
| ) |  |

Definition at line 7505 of file io.c.

## ◆ rb_io_puts()

VALUE rb_io_puts | ( | int | ,
|  | const VALUE * | ,
|  | VALUE |
| ) |  |

Definition at line 7747 of file io.c.

Referenced by rb_f_abort().

## ◆ rb_io_ungetbyte()

VALUE rb_io_ungetbyte | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 4276 of file io.c.

## ◆ rb_io_ungetc()

VALUE rb_io_ungetc | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 4315 of file io.c.

## ◆ rb_io_write()

VALUE rb_io_write | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1804 of file io.c.

Referenced by rb_parser_printf().

## ◆ rb_is_absolute_path()

int rb_is_absolute_path | ( | const char * |  | ) |

Definition at line 6089 of file file.c.

## ◆ rb_ivar_count()

st_index_t rb_ivar_count | ( | VALUE |  | ) |

Definition at line 1511 of file variable.c.

## ◆ rb_ivar_defined()

VALUE rb_ivar_defined | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 1317 of file variable.c.

## ◆ rb_ivar_foreach()

void rb_ivar_foreach | ( | VALUE | ,
|  | int(*)(ID, VALUE, st_data_t) | ,
|  | st_data_t |
| ) |  |

## ◆ rb_ivar_get()

VALUE rb_ivar_get | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 1070 of file variable.c.

Referenced by rb_class_modify_check(), rb_method_name_error(), and rb_singleton_class_get().

## ◆ rb_ivar_set()

VALUE rb_ivar_set | ( | VALUE | ,
|  | ID | ,
|  | VALUE |
| ) |  |

Definition at line 1300 of file variable.c.

Referenced by rb_error_frozen_object(), rb_frozen_error_raise(), and rb_key_err_new().

## ◆ rb_last_status_get()

VALUE rb_last_status_get | ( | void |  | ) |

Definition at line 518 of file process.c.

## ◆ rb_last_status_set()

void rb_last_status_set | ( | int | status,
|  | rb_pid_t | pid
| ) |  |

Definition at line 545 of file process.c.

References GET_THREAD, rb_thread_struct::last_status, and rb_obj_alloc().

## ◆ rb_lastline_get()

VALUE rb_lastline_get | ( | void |  | ) |

Definition at line 1316 of file vm.c.

Referenced by rb_io_print(), and rb_reg_match2().

## ◆ rb_lastline_set()

void rb_lastline_set | ( | VALUE |  | ) |

Definition at line 1322 of file vm.c.

## ◆ rb_load()

void rb_load | ( | VALUE | ,
|  | int |
| ) |  |

Definition at line 649 of file load.c.

## ◆ rb_load_file()

void* rb_load_file | ( | const char * |  | ) |

Definition at line 2180 of file ruby.c.

## ◆ rb_load_file_str()

void* rb_load_file_str | ( | VALUE |  | ) |

Definition at line 2187 of file ruby.c.

## ◆ rb_load_protect()

void rb_load_protect | ( | VALUE | ,
|  | int | ,
|  | int * |
| ) |  |

Definition at line 657 of file load.c.

## ◆ rb_locale_str_new()

VALUE rb_locale_str_new | ( | const char * | ,
|  | long |
| ) |  |

Definition at line 1099 of file string.c.

## ◆ rb_locale_str_new_cstr()

VALUE rb_locale_str_new_cstr | ( | const char * |  | ) |

Definition at line 1105 of file string.c.

## ◆ rb_make_backtrace()

VALUE rb_make_backtrace | ( | void |  | ) |

Definition at line 872 of file vm_backtrace.c.

## ◆ rb_mark_hash()

void rb_mark_hash | ( | struct st_table * |  | ) |

Definition at line 4862 of file gc.c.

## ◆ rb_mark_set()

void rb_mark_set | ( | struct st_table * |  | ) |

Definition at line 4798 of file gc.c.

## ◆ rb_mark_tbl()

void rb_mark_tbl | ( | struct st_table * |  | ) |

Definition at line 5005 of file gc.c.

## ◆ rb_mark_tbl_no_pin()

void rb_mark_tbl_no_pin | ( | struct st_table * |  | ) |

Definition at line 5011 of file gc.c.

## ◆ rb_marshal_define_compat()

void rb_marshal_define_compat | ( | VALUE | newclass,
|  | VALUE | oldclass,
|  | VALUE(*)(VALUE) | dumper,
|  | VALUE(*)(VALUE, VALUE) | loader
| ) |  |

Definition at line 133 of file marshal.c.

## ◆ rb_marshal_dump()

VALUE rb_marshal_dump | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 2310 of file marshal.c.

## ◆ rb_marshal_load()

VALUE rb_marshal_load | ( | VALUE |  | ) |

Definition at line 2316 of file marshal.c.

## ◆ rb_match_busy()

void rb_match_busy | ( | VALUE |  | ) |

Definition at line 1287 of file re.c.

## ◆ rb_mem_clear()

void rb_mem_clear | ( | VALUE * | ,
|  | long |
| ) |  |

Definition at line 243 of file array.c.

## ◆ rb_memcicmp()

int rb_memcicmp | ( | const void * | ,
|  | const void * | ,
|  | long |
| ) |  |

Definition at line 80 of file re.c.

## ◆ rb_memhash()

st_index_t rb_memhash | ( | const void * | ptr,
|  | long | len
| ) |  |

Definition at line 1440 of file random.c.

Referenced by rb_dbl_long_hash(), and rb_str_hash().

## ◆ rb_memory_id()

VALUE rb_memory_id | ( | VALUE |  | ) |

Definition at line 3737 of file gc.c.

## ◆ rb_method_basic_definition_p()

int rb_method_basic_definition_p | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 2072 of file vm_method.c.

## ◆ rb_method_boundp()

int rb_method_boundp | ( | VALUE | ,
|  | ID | ,
|  | int |
| ) |  |

Definition at line 1102 of file vm_method.c.

## ◆ rb_method_call()

VALUE rb_method_call | ( | int | ,
|  | const VALUE * | ,
|  | VALUE |
| ) |  |

Definition at line 2261 of file proc.c.

## ◆ rb_method_call_kw()

VALUE rb_method_call_kw | ( | int | ,
|  | const VALUE * | ,
|  | VALUE | ,
|  | int |
| ) |  |

Definition at line 2254 of file proc.c.

## ◆ rb_method_call_with_block()

VALUE rb_method_call_with_block | ( | int | ,
|  | const VALUE * | ,
|  | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 2297 of file proc.c.

## ◆ rb_method_call_with_block_kw()

VALUE rb_method_call_with_block_kw | ( | int | ,
|  | const VALUE * | ,
|  | VALUE | ,
|  | VALUE | ,
|  | int |
| ) |  |

Definition at line 2284 of file proc.c.

## ◆ rb_mod_class_variables()

VALUE rb_mod_class_variables | ( | int | ,
|  | const VALUE * | ,
|  | VALUE |
| ) |  |

Definition at line 3237 of file variable.c.

## ◆ rb_mod_const_at()

void* rb_mod_const_at | ( | VALUE | ,
|  | void * |
| ) |  |

Definition at line 2559 of file variable.c.

## ◆ rb_mod_const_of()

void* rb_mod_const_of | ( | VALUE | ,
|  | void * |
| ) |  |

Definition at line 2572 of file variable.c.

## ◆ rb_mod_constants()

VALUE rb_mod_constants | ( | int | ,
|  | const VALUE * | ,
|  | VALUE |
| ) |  |

Definition at line 2626 of file variable.c.

## ◆ rb_mod_method_arity()

int rb_mod_method_arity | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 2632 of file proc.c.

## ◆ rb_mod_module_eval()

VALUE rb_mod_module_eval | ( | int | ,
|  | const VALUE * | ,
|  | VALUE |
| ) |  |

Definition at line 2067 of file vm_eval.c.

## ◆ rb_mod_module_exec()

VALUE rb_mod_module_exec | ( | int | ,
|  | const VALUE * | ,
|  | VALUE |
| ) |  |

Definition at line 2101 of file vm_eval.c.

## ◆ rb_mod_name()

VALUE rb_mod_name | ( | VALUE |  | ) |

Definition at line 102 of file variable.c.

## ◆ rb_mod_remove_const()

VALUE rb_mod_remove_const | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 2479 of file variable.c.

## ◆ rb_mod_remove_cvar()

VALUE rb_mod_remove_cvar | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 3273 of file variable.c.

## ◆ rb_must_asciicompat()

void rb_must_asciicompat | ( | VALUE |  | ) |

Definition at line 2166 of file string.c.

Referenced by rb_str_convert_to_inum().

## ◆ rb_mutex_lock()

VALUE rb_mutex_lock | ( | VALUE | mutex | ) |

Definition at line 333 of file thread_sync.c.

## ◆ rb_mutex_locked_p()

VALUE rb_mutex_locked_p | ( | VALUE | mutex | ) |

Definition at line 177 of file thread_sync.c.

## ◆ rb_mutex_new()

VALUE rb_mutex_new | ( | void |  | ) |

Definition at line 165 of file thread_sync.c.

## ◆ rb_mutex_sleep()

VALUE rb_mutex_sleep | ( | VALUE | self,
|  | VALUE | timeout
| ) |  |

Definition at line 465 of file thread_sync.c.

## ◆ rb_mutex_synchronize()

VALUE rb_mutex_synchronize | ( | VALUE | mutex,
|  | VALUE(*)(VALUE arg) | func,
|  | VALUE | arg
| ) |  |

Definition at line 522 of file thread_sync.c.

## ◆ rb_mutex_trylock()

VALUE rb_mutex_trylock | ( | VALUE | mutex | ) |

Definition at line 203 of file thread_sync.c.

## ◆ rb_mutex_unlock()

VALUE rb_mutex_unlock | ( | VALUE | mutex | ) |

Definition at line 403 of file thread_sync.c.

## ◆ rb_num2fix()

VALUE rb_num2fix | ( | VALUE |  | ) |

Definition at line 3083 of file numeric.c.

## ◆ rb_num_coerce_bin()

VALUE rb_num_coerce_bin | ( | VALUE | ,
|  | VALUE | ,
|  | ID |
| ) |  |

Definition at line 446 of file numeric.c.

Referenced by rb_big_divmod(), rb_big_modulo(), rb_big_mul(), and rb_big_remainder().

## ◆ rb_num_coerce_bit()

VALUE rb_num_coerce_bit | ( | VALUE | ,
|  | VALUE | ,
|  | ID |
| ) |  |

Definition at line 4426 of file numeric.c.

Referenced by rb_big_and(), rb_big_or(), and rb_big_xor().

## ◆ rb_num_coerce_cmp()

VALUE rb_num_coerce_cmp | ( | VALUE | ,
|  | VALUE | ,
|  | ID |
| ) |  |

Definition at line 453 of file numeric.c.

## ◆ rb_num_coerce_relop()

VALUE rb_num_coerce_relop | ( | VALUE | ,
|  | VALUE | ,
|  | ID |
| ) |  |

Definition at line 461 of file numeric.c.

## ◆ rb_obj_as_string()

VALUE rb_obj_as_string | ( | VALUE |  | ) |

Definition at line 1440 of file string.c.

Referenced by rb_inspect(), and rb_p().

## ◆ rb_obj_call_init_kw()

void rb_obj_call_init_kw | ( | VALUE | ,
|  | int | ,
|  | const VALUE * | ,
|  | int |
| ) |  |

Definition at line 1687 of file eval.c.

## ◆ rb_obj_id()

VALUE rb_obj_id | ( | VALUE |  | ) |

Definition at line 3770 of file gc.c.

## ◆ rb_obj_instance_eval()

VALUE rb_obj_instance_eval | ( | int | ,
|  | const VALUE * | ,
|  | VALUE |
| ) |  |

Definition at line 1995 of file vm_eval.c.

## ◆ rb_obj_instance_exec()

VALUE rb_obj_instance_exec | ( | int | ,
|  | const VALUE * | ,
|  | VALUE |
| ) |  |

Definition at line 2027 of file vm_eval.c.

## ◆ rb_obj_instance_variables()

VALUE rb_obj_instance_variables | ( | VALUE |  | ) |

Definition at line 1579 of file variable.c.

## ◆ rb_obj_is_method()

VALUE rb_obj_is_method | ( | VALUE |  | ) |

Definition at line 1459 of file proc.c.

## ◆ rb_obj_is_proc()

VALUE rb_obj_is_proc | ( | VALUE |  | ) |

Definition at line 152 of file proc.c.

## ◆ rb_obj_method()

VALUE rb_obj_method | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1861 of file proc.c.

## ◆ rb_obj_method_arity()

int rb_obj_method_arity | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 2640 of file proc.c.

## ◆ rb_obj_remove_instance_variable()

VALUE rb_obj_remove_instance_variable | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1634 of file variable.c.

## ◆ rb_obj_respond_to()

int rb_obj_respond_to | ( | VALUE | ,
|  | ID | ,
|  | int |
| ) |  |

Definition at line 2180 of file vm_method.c.

## ◆ rb_path2class()

VALUE rb_path2class | ( | const char * |  | ) |

Definition at line 268 of file variable.c.

Referenced by Init_ossl_digest().

## ◆ rb_path_check()

int rb_path_check | ( | const char * |  | ) |

Definition at line 6168 of file file.c.

## ◆ rb_path_to_class()

VALUE rb_path_to_class | ( | VALUE |  | ) |

Definition at line 226 of file variable.c.

## ◆ rb_pipe()

int rb_pipe | ( | int * | pipes | ) |

Definition at line 6369 of file io.c.

## ◆ rb_proc_arity()

int rb_proc_arity | ( | VALUE |  | ) |

Definition at line 1112 of file proc.c.

## ◆ rb_proc_call()

VALUE rb_proc_call | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 966 of file proc.c.

Referenced by rb_call_end_proc().

## ◆ rb_proc_call_kw()

VALUE rb_proc_call_kw | ( | VALUE | ,
|  | VALUE | ,
|  | int |
| ) |  |

Definition at line 948 of file proc.c.

## ◆ rb_proc_call_with_block()

VALUE rb_proc_call_with_block | ( | VALUE | ,
|  | int | argc,
|  | const VALUE * | argv,
|  | VALUE |
| ) |  |

Definition at line 1000 of file proc.c.

## ◆ rb_proc_call_with_block_kw()

VALUE rb_proc_call_with_block_kw | ( | VALUE | ,
|  | int | argc,
|  | const VALUE * | argv,
|  | VALUE | ,
|  | int |
| ) |  |

Definition at line 986 of file proc.c.

## ◆ rb_proc_exec()

int rb_proc_exec | ( | const char * |  | ) |

Definition at line 1665 of file process.c.

## ◆ rb_proc_lambda_p()

VALUE rb_proc_lambda_p | ( | VALUE |  | ) |

Definition at line 275 of file proc.c.

## ◆ rb_proc_new()

VALUE rb_proc_new | ( | rb_block_call_func_t | ,
|  | VALUE |
| ) |  |

Definition at line 2979 of file proc.c.

## ◆ rb_proc_times()

VALUE rb_proc_times | ( | VALUE |  | ) |

## ◆ rb_provide()

void rb_provide | ( | const char * |  | ) |

Definition at line 563 of file load.c.

## ◆ rb_provided()

int rb_provided | ( | const char * |  | ) |

Definition at line 513 of file load.c.

## ◆ rb_random_bytes()

VALUE rb_random_bytes | ( | VALUE | rnd,
|  | long | n
| ) |  |

Definition at line 1021 of file random.c.

## ◆ rb_random_int()

VALUE rb_random_int | ( | VALUE | rnd,
|  | VALUE | max
| ) |  |

## ◆ rb_random_int32()

unsigned int rb_random_int32 | ( | VALUE | rnd | ) |

Definition at line 835 of file random.c.

## ◆ rb_random_real()

double rb_random_real | ( | VALUE | rnd | ) |

Definition at line 870 of file random.c.

## ◆ rb_random_ulong_limited()

unsigned long rb_random_ulong_limited | ( | VALUE | rnd,
|  | unsigned long | limit
| ) |  |

Definition at line 930 of file random.c.

## ◆ rb_range_beg_len()

VALUE rb_range_beg_len | ( | VALUE | ,
|  | long * | ,
|  | long * | ,
|  | long | ,
|  | int |
| ) |  |

Definition at line 1273 of file range.c.

Referenced by rb_ary_aref1().

## ◆ rb_range_new()

VALUE rb_range_new | ( | VALUE | ,
|  | VALUE | ,
|  | int |
| ) |  |

Definition at line 52 of file range.c.

## ◆ rb_range_values()

int rb_range_values | ( | VALUE | range,
|  | VALUE * | begp,
|  | VALUE * | endp,
|  | int * | exclp
| ) |  |

Definition at line 1243 of file range.c.

## ◆ rb_Rational()

VALUE rb_Rational | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1951 of file rational.c.

## ◆ rb_rational_den()

VALUE rb_rational_den | ( | VALUE | rat | ) |

Definition at line 1966 of file rational.c.

## ◆ rb_rational_new()

VALUE rb_rational_new | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1945 of file rational.c.

## ◆ rb_rational_num()

VALUE rb_rational_num | ( | VALUE | rat | ) |

Definition at line 1960 of file rational.c.

## ◆ rb_rational_raw()

VALUE rb_rational_raw | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1939 of file rational.c.

## ◆ rb_reg_alloc()

VALUE rb_reg_alloc | ( | void |  | ) |

Definition at line 2888 of file re.c.

## ◆ rb_reg_backref_number()

int rb_reg_backref_number | ( | VALUE | match,
|  | VALUE | backref
| ) |  |

Definition at line 1173 of file re.c.

## ◆ rb_reg_init_str()

VALUE rb_reg_init_str | ( | VALUE | re,
|  | VALUE | s,
|  | int | options
| ) |  |

Definition at line 2900 of file re.c.

## ◆ rb_reg_last_match()

VALUE rb_reg_last_match | ( | VALUE |  | ) |

Definition at line 1731 of file re.c.

## ◆ rb_reg_match()

VALUE rb_reg_match | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 3179 of file re.c.

## ◆ rb_reg_match2()

VALUE rb_reg_match2 | ( | VALUE |  | ) |

Definition at line 3238 of file re.c.

## ◆ rb_reg_match_last()

VALUE rb_reg_match_last | ( | VALUE |  | ) |

Definition at line 1792 of file re.c.

## ◆ rb_reg_match_post()

VALUE rb_reg_match_post | ( | VALUE |  | ) |

Definition at line 1775 of file re.c.

## ◆ rb_reg_match_pre()

VALUE rb_reg_match_pre | ( | VALUE |  | ) |

Definition at line 1749 of file re.c.

## ◆ rb_reg_new()

VALUE rb_reg_new | ( | const char * | ,
|  | long | ,
|  | int |
| ) |  |

Definition at line 2946 of file re.c.

## ◆ rb_reg_new_str()

VALUE rb_reg_new_str | ( | VALUE | ,
|  | int |
| ) |  |

Definition at line 2894 of file re.c.

## ◆ rb_reg_nth_defined()

VALUE rb_reg_nth_defined | ( | int | ,
|  | VALUE |
| ) |  |

Definition at line 1688 of file re.c.

## ◆ rb_reg_nth_match()

VALUE rb_reg_nth_match | ( | int | ,
|  | VALUE |
| ) |  |

Definition at line 1706 of file re.c.

## ◆ rb_reg_options()

int rb_reg_options | ( | VALUE |  | ) |

Definition at line 3578 of file re.c.

## ◆ rb_remove_method()

void rb_remove_method | ( | VALUE | ,
|  | const char * |
| ) |  |

Definition at line 1032 of file vm_method.c.

## ◆ rb_remove_method_id()

void rb_remove_method_id | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 1026 of file vm_method.c.

## ◆ rb_require_safe()

VALUE rb_require_safe | ( | VALUE | ,
|  | int |
| ) |  |

Definition at line 1085 of file load.c.

## ◆ rb_require_string()

VALUE rb_require_string | ( | VALUE |  | ) |

Definition at line 1102 of file load.c.

## ◆ rb_reserved_fd_p()

int rb_reserved_fd_p | ( | int | fd | ) |

Referenced by rsock_init_sock().

## ◆ rb_reset_random_seed()

void rb_reset_random_seed | ( | void |  | ) |

Definition at line 1498 of file random.c.

## ◆ rb_respond_to()

int rb_respond_to | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 2190 of file vm_method.c.

Referenced by ossl_to_der_if_possible(), and rb_str_equal().

## ◆ rb_set_class_path()

void rb_set_class_path | ( | VALUE | ,
|  | VALUE | ,
|  | const char * |
| ) |  |

Definition at line 218 of file variable.c.

## ◆ rb_set_class_path_string()

void rb_set_class_path_string | ( | VALUE | ,
|  | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 198 of file variable.c.

Referenced by rb_define_class_id_under(), and rb_define_module_id_under().

## ◆ rb_set_end_proc()

void rb_set_end_proc | ( | void(*)(VALUE) | ,
|  | VALUE |
| ) |  |

Definition at line 59 of file eval_jump.c.

## ◆ rb_sourcefile()

const char* rb_sourcefile | ( | void |  | ) |

Definition at line 1331 of file vm.c.

## ◆ rb_sourceline()

int rb_sourceline | ( | void |  | ) |

Definition at line 1346 of file vm.c.

## ◆ rb_spawn()

rb_pid_t rb_spawn | ( | int | ,
|  | const VALUE * |
| ) |  |

Definition at line 4441 of file process.c.

## ◆ rb_spawn_err()

rb_pid_t rb_spawn_err | ( | int | ,
|  | const VALUE * | ,
|  | char * | ,
|  | size_t |
| ) |  |

Definition at line 4435 of file process.c.

## ◆ rb_st_foreach_safe()

void rb_st_foreach_safe | ( | struct st_table * | ,
|  | int(*)(st_data_t, st_data_t, st_data_t) | ,
|  | st_data_t |
| ) |  |

## ◆ rb_str2inum()

VALUE rb_str2inum | ( | VALUE | ,
|  | int |
| ) |  |

Definition at line 4544 of file bignum.c.

## ◆ rb_str_append()

VALUE rb_str_append | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 2965 of file string.c.

Referenced by rb_keyword_error_new(), and rb_load_fail().

## ◆ rb_str_buf_append()

VALUE rb_str_buf_append | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 2950 of file string.c.

## ◆ rb_str_buf_cat()

VALUE rb_str_buf_cat | ( | VALUE | ,
|  | const char * | ,
|  | long |
| ) |  |

## ◆ rb_str_buf_cat2()

VALUE rb_str_buf_cat2 | ( | VALUE | ,
|  | const char * |
| ) |  |

## ◆ rb_str_buf_cat_ascii()

VALUE rb_str_buf_cat_ascii | ( | VALUE | ,
|  | const char * |
| ) |  |

Definition at line 2926 of file string.c.

## ◆ rb_str_buf_new()

VALUE rb_str_buf_new | ( | long |  | ) |

Definition at line 1315 of file string.c.

Referenced by rb_econv_append(), and rb_reg_regsub().

## ◆ rb_str_buf_new2()

VALUE rb_str_buf_new2 | ( | const char * |  | ) |

## ◆ rb_str_buf_new_cstr()

VALUE rb_str_buf_new_cstr | ( | const char * |  | ) |

Definition at line 1331 of file string.c.

## ◆ rb_str_cat()

VALUE rb_str_cat | ( | VALUE | ,
|  | const char * | ,
|  | long |
| ) |  |

Definition at line 2812 of file string.c.

Referenced by rsock_inspect_sockaddr().

## ◆ rb_str_cat2()

VALUE rb_str_cat2 | ( | VALUE | ,
|  | const char * |
| ) |  |

## ◆ rb_str_cat_cstr()

VALUE rb_str_cat_cstr | ( | VALUE | ,
|  | const char * |
| ) |  |

Definition at line 2822 of file string.c.

## ◆ rb_str_cmp()

int rb_str_cmp | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 3228 of file string.c.

Referenced by rb_iseq_pathobj_new().

## ◆ rb_str_comparable()

int rb_str_comparable | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 3203 of file string.c.

## ◆ rb_str_concat()

VALUE rb_str_concat | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 3065 of file string.c.

Referenced by make_inspect(), and rb_iseq_disasm_insn().

## ◆ rb_str_drop_bytes()

VALUE rb_str_drop_bytes | ( | VALUE | ,
|  | long |
| ) |  |

Definition at line 4573 of file string.c.

## ◆ rb_str_dump()

VALUE rb_str_dump | ( | VALUE |  | ) |

Definition at line 6042 of file string.c.

## ◆ rb_str_dup()

VALUE rb_str_dup | ( | VALUE |  | ) |

Definition at line 1516 of file string.c.

Referenced by rb_vm_set_progname(), rsock_ipaddr(), and ruby_set_script_name().

## ◆ rb_str_dup_frozen()

VALUE rb_str_dup_frozen | ( | VALUE |  | ) |

## ◆ rb_str_ellipsize()

VALUE rb_str_ellipsize | ( | VALUE | str,
|  | long | len
| ) |  |

Shortens str and adds three dots, an ellipsis, if it is longer than len characters.

Parameters

  str | the string to ellipsize.
  len | the maximum string length.

Returns
  the ellipsized string.

Precondition
  len must not be negative.

Postcondition
  the length of the returned string in characters is less than or equal to len.
  If the length of str is less than or equal len, returns str itself.
  the encoding of returned string is equal to the encoding of str.
  the class of returned string is equal to the class of str.

Note
  the length is counted in characters.

Definition at line 10185 of file string.c.

## ◆ rb_str_encode_ospath()

VALUE rb_str_encode_ospath | ( | VALUE |  | ) |

Definition at line 236 of file file.c.

## ◆ rb_str_equal()

VALUE rb_str_equal | ( | VALUE | str1,
|  | VALUE | str2
| ) |  |

Definition at line 3267 of file string.c.

## ◆ rb_str_format()

VALUE rb_str_format | ( | int | ,
|  | const VALUE * | ,
|  | VALUE |
| ) |  |

Definition at line 204 of file sprintf.c.

## ◆ rb_str_free()

void rb_str_free | ( | VALUE |  | ) |

Definition at line 1349 of file string.c.

## ◆ rb_str_freeze()

VALUE rb_str_freeze | ( | VALUE |  | ) |

Definition at line 2616 of file string.c.

## ◆ rb_str_hash()

st_index_t rb_str_hash | ( | VALUE |  | ) |

Definition at line 3163 of file string.c.

## ◆ rb_str_hash_cmp()

int rb_str_hash_cmp | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 3173 of file string.c.

## ◆ rb_str_inspect()

VALUE rb_str_inspect | ( | VALUE |  | ) |

Definition at line 5930 of file string.c.

## ◆ rb_str_intern()

VALUE rb_str_intern | ( | VALUE |  | ) |

Definition at line 710 of file symbol.c.

## ◆ rb_str_length()

VALUE rb_str_length | ( | VALUE |  | ) |

Definition at line 1843 of file string.c.

## ◆ rb_str_locktmp()

VALUE rb_str_locktmp | ( | VALUE |  | ) |

Referenced by rb_str_locktmp_ensure().

## ◆ rb_str_modify()

void rb_str_modify | ( | VALUE |  | ) |

Definition at line 2114 of file string.c.

Referenced by rb_str_vcatf().

## ◆ rb_str_modify_expand()

void rb_str_modify_expand | ( | VALUE | ,
|  | long |
| ) |  |

Definition at line 2122 of file string.c.

## ◆ rb_str_new()

VALUE rb_str_new | ( | const char * | ,
|  | long |
| ) |  |

Definition at line 774 of file string.c.

## ◆ rb_str_new_cstr()

VALUE rb_str_new_cstr | ( | const char * |  | ) |

Definition at line 808 of file string.c.

## ◆ rb_str_new_frozen()

VALUE rb_str_new_frozen | ( | VALUE |  | ) |

Definition at line 1203 of file string.c.

Referenced by rb_econv_substr_append(), and rb_hash_key_str().

## ◆ rb_str_new_shared()

VALUE rb_str_new_shared | ( | VALUE |  | ) |

Definition at line 1197 of file string.c.

## ◆ rb_str_new_static()

VALUE rb_str_new_static | ( | const char * | ,
|  | long |
| ) |  |

Definition at line 872 of file string.c.

## ◆ rb_str_new_with_class()

VALUE rb_str_new_with_class | ( | VALUE | ,
|  | const char * | ,
|  | long |
| ) |  |

Definition at line 1298 of file string.c.

## ◆ rb_str_offset()

long rb_str_offset | ( | VALUE | ,
|  | long |
| ) |  |

Definition at line 2416 of file string.c.

## ◆ rb_str_plus()

VALUE rb_str_plus | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1894 of file string.c.

## ◆ rb_str_replace()

VALUE rb_str_replace | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 5363 of file string.c.

## ◆ rb_str_resize()

VALUE rb_str_resize | ( | VALUE | ,
|  | long |
| ) |  |

Definition at line 2709 of file string.c.

Referenced by rb_econv_append(), rb_reg_quote(), ruby_init_loadpath(), and VpAlloc().

## ◆ rb_str_resurrect()

VALUE rb_str_resurrect | ( | VALUE | str | ) |

Definition at line 1522 of file string.c.

## ◆ rb_str_scrub()

VALUE rb_str_scrub | ( | VALUE | str,
|  | VALUE | repl
| ) |  |

Parameters

  str | the string to be scrubbed
  repl | the replacement character

Returns
  If given string is invalid, returns a new string. Otherwise, returns Qnil.

Definition at line 10248 of file string.c.

## ◆ rb_str_set_len()

void rb_str_set_len | ( | VALUE | ,
|  | long |
| ) |  |

Definition at line 2692 of file string.c.

Referenced by rb_econv_append().

## ◆ rb_str_shared_replace()

void rb_str_shared_replace | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1391 of file string.c.

## ◆ rb_str_split()

VALUE rb_str_split | ( | VALUE | ,
|  | const char * |
| ) |  |

Definition at line 8116 of file string.c.

## ◆ rb_str_strlen()

long rb_str_strlen | ( | VALUE |  | ) |

Definition at line 1829 of file string.c.

## ◆ rb_str_sublen()

long rb_str_sublen | ( | VALUE | ,
|  | long |
| ) |  |

Definition at line 2463 of file string.c.

Referenced by rb_reg_match2().

## ◆ rb_str_subpos()

char* rb_str_subpos | ( | VALUE | ,
|  | long | ,
|  | long * |
| ) |  |

Definition at line 2497 of file string.c.

## ◆ rb_str_subseq()

VALUE rb_str_subseq | ( | VALUE | ,
|  | long | ,
|  | long |
| ) |  |

Definition at line 2474 of file string.c.

Referenced by rb_path_to_class(), rb_reg_regsub(), and ruby_init_loadpath().

## ◆ rb_str_substr()

VALUE rb_str_substr | ( | VALUE | ,
|  | long | ,
|  | long |
| ) |  |

Definition at line 2584 of file string.c.

## ◆ rb_str_succ()

VALUE rb_str_succ | ( | VALUE |  | ) |

Definition at line 4090 of file string.c.

## ◆ rb_str_times()

VALUE rb_str_times | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1966 of file string.c.

## ◆ rb_str_tmp_new()

VALUE rb_str_tmp_new | ( | long |  | ) |

Definition at line 1343 of file string.c.

Referenced by VpAlloc().

## ◆ rb_str_to_inum()

VALUE rb_str_to_inum | ( | VALUE | ,
|  | int | ,
|  | int |
| ) |  |

Definition at line 4268 of file bignum.c.

## ◆ rb_str_unlocktmp()

VALUE rb_str_unlocktmp | ( | VALUE |  | ) |

Definition at line 2675 of file string.c.

## ◆ rb_str_update()

void rb_str_update | ( | VALUE | ,
|  | long | ,
|  | long | ,
|  | VALUE |
| ) |  |

Definition at line 4643 of file string.c.

## ◆ rb_str_vcatf()

VALUE rb_str_vcatf | ( | VALUE | ,
|  | const char * | ,
|  | va_list |
| ) |  |

Definition at line 1210 of file sprintf.c.

Referenced by rb_parser_fatal(), and rb_parser_printf().

## ◆ rb_struct_alloc()

VALUE rb_struct_alloc | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 727 of file struct.c.

## ◆ rb_struct_alloc_noinit()

VALUE rb_struct_alloc_noinit | ( | VALUE |  | ) |

Definition at line 352 of file struct.c.

## ◆ rb_struct_aref()

VALUE rb_struct_aref | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1064 of file struct.c.

Referenced by rb_vm_opt_struct_aref().

## ◆ rb_struct_aset()

VALUE rb_struct_aset | ( | VALUE | ,
|  | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 1091 of file struct.c.

Referenced by rb_vm_opt_struct_aset().

## ◆ rb_struct_define()

VALUE rb_struct_define | ( | const char * | ,
|  |  | ...
| ) |  |

Definition at line 434 of file struct.c.

## ◆ rb_struct_define_under()

VALUE rb_struct_define_under | ( | VALUE | ,
|  | const char * | ,
|  |  | ...
| ) |  |

Definition at line 449 of file struct.c.

## ◆ rb_struct_define_without_accessor()

VALUE rb_struct_define_without_accessor | ( | const char * | ,
|  | VALUE | ,
|  | rb_alloc_func_t | ,
|  |  | ...
| ) |  |

Definition at line 421 of file struct.c.

## ◆ rb_struct_define_without_accessor_under()

VALUE rb_struct_define_without_accessor_under | ( | VALUE | outer,
|  | const char * | class_name,
|  | VALUE | super,
|  | rb_alloc_func_t | alloc,
|  |  | ...
| ) |  |

Definition at line 408 of file struct.c.

## ◆ rb_struct_getmember()

VALUE rb_struct_getmember | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 211 of file struct.c.

## ◆ rb_struct_initialize()

VALUE rb_struct_initialize | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 662 of file struct.c.

## ◆ rb_struct_members()

VALUE rb_struct_members | ( | VALUE |  | ) |

Definition at line 72 of file struct.c.

## ◆ rb_struct_new()

VALUE rb_struct_new | ( | VALUE | ,
|  |  | ...
| ) |  |

Definition at line 733 of file struct.c.

## ◆ rb_struct_s_members()

VALUE rb_struct_s_members | ( | VALUE |  | ) |

Definition at line 58 of file struct.c.

## ◆ rb_struct_size()

VALUE rb_struct_size | ( | VALUE | s | ) |

Definition at line 1294 of file struct.c.

## ◆ rb_sym_all_symbols()

VALUE rb_sym_all_symbols | ( | void |  | ) |

Definition at line 840 of file symbol.c.

## ◆ rb_sym_interned_p()

int rb_sym_interned_p | ( | VALUE |  | ) |

## ◆ rb_sym_to_s()

VALUE rb_sym_to_s | ( | VALUE |  | ) |

Definition at line 10793 of file string.c.

## ◆ rb_symname_p()

int rb_symname_p | ( | const char * |  | ) |

Definition at line 182 of file symbol.c.

## ◆ rb_syswait()

void rb_syswait | ( | rb_pid_t | pid | ) |

Definition at line 4308 of file process.c.

References rb_waitpid().

## ◆ rb_tainted_str_new()

VALUE rb_tainted_str_new | ( | const char * | ,
|  | long |
| ) |  |

Definition at line 896 of file string.c.

## ◆ rb_tainted_str_new_cstr()

VALUE rb_tainted_str_new_cstr | ( | const char * |  | ) |

Definition at line 903 of file string.c.

## ◆ rb_thread_alone()

int rb_thread_alone | ( | void |  | ) |

Definition at line 3492 of file thread.c.

## ◆ rb_thread_atfork()

void rb_thread_atfork | ( | void |  | ) |

Definition at line 4548 of file thread.c.

## ◆ rb_thread_atfork_before_exec()

void rb_thread_atfork_before_exec | ( | void |  | ) |

Definition at line 4553 of file thread.c.

## ◆ rb_thread_check_ints()

void rb_thread_check_ints | ( | void |  | ) |

Definition at line 1362 of file thread.c.

## ◆ rb_thread_create()

VALUE rb_thread_create | ( | VALUE(*)(void *) | ,
|  | void * |
| ) |  |

Definition at line 966 of file thread.c.

## ◆ rb_thread_current()

VALUE rb_thread_current | ( | void |  | ) |

Definition at line 2676 of file thread.c.

Referenced by VpGetPrecLimit(), and VpGetRoundMode().

## ◆ rb_thread_fd_close()

void rb_thread_fd_close | ( | int |  | ) |

Definition at line 2386 of file thread.c.

## ◆ rb_thread_fd_select()

int rb_thread_fd_select | ( | int | ,
|  | rb_fdset_t * | ,
|  | rb_fdset_t * | ,
|  | rb_fdset_t * | ,
|  | struct timeval * |
| ) |  |

Definition at line 4067 of file thread.c.

## ◆ rb_thread_fd_writable()

int rb_thread_fd_writable | ( | int |  | ) |

Definition at line 4048 of file thread.c.

## ◆ rb_thread_interrupted()

int rb_thread_interrupted | ( | VALUE | thval | ) |

Definition at line 1379 of file thread.c.

## ◆ rb_thread_kill()

VALUE rb_thread_kill | ( | VALUE |  | ) |

Definition at line 2446 of file thread.c.

## ◆ rb_thread_local_aref()

VALUE rb_thread_local_aref | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 3216 of file thread.c.

Referenced by VpGetPrecLimit(), and VpGetRoundMode().

## ◆ rb_thread_local_aset()

VALUE rb_thread_local_aset | ( | VALUE | ,
|  | ID | ,
|  | VALUE |
| ) |  |

Definition at line 3364 of file thread.c.

## ◆ rb_thread_main()

VALUE rb_thread_main | ( | void |  | ) |

Definition at line 2697 of file thread.c.

## ◆ rb_thread_run()

VALUE rb_thread_run | ( | VALUE |  | ) |

Definition at line 2587 of file thread.c.

## ◆ rb_thread_schedule()

void rb_thread_schedule | ( | void |  | ) |

Definition at line 1408 of file thread.c.

## ◆ rb_thread_sleep()

void rb_thread_sleep | ( | int |  | ) |

Definition at line 1385 of file thread.c.

## ◆ rb_thread_sleep_deadly()

void rb_thread_sleep_deadly | ( | void |  | ) |

Definition at line 1321 of file thread.c.

## ◆ rb_thread_sleep_forever()

void rb_thread_sleep_forever | ( | void |  | ) |

Definition at line 1314 of file thread.c.

## ◆ rb_thread_stop()

VALUE rb_thread_stop | ( | void |  | ) |

Definition at line 2596 of file thread.c.

## ◆ rb_thread_wait_fd()

void rb_thread_wait_fd | ( | int |  | ) |

Definition at line 4042 of file thread.c.

Referenced by rb_io_read_check().

## ◆ rb_thread_wait_for()

void rb_thread_wait_for | ( | struct timeval |  | ) |

Definition at line 1347 of file thread.c.

## ◆ rb_thread_wakeup()

VALUE rb_thread_wakeup | ( | VALUE |  | ) |

Definition at line 2540 of file thread.c.

## ◆ rb_thread_wakeup_alive()

VALUE rb_thread_wakeup_alive | ( | VALUE |  | ) |

Definition at line 2549 of file thread.c.

## ◆ rb_time_interval()

struct timeval rb_time_interval | ( | VALUE | num | ) |

Definition at line 2669 of file time.c.

Referenced by rb_mutex_sleep().

## ◆ rb_time_nano_new()

VALUE rb_time_nano_new | ( | time_t | ,
|  | long |
| ) |  |

Definition at line 2519 of file time.c.

## ◆ rb_time_new()

VALUE rb_time_new | ( | time_t | ,
|  | long |
| ) |  |

Definition at line 2492 of file time.c.

## ◆ rb_time_num_new()

VALUE rb_time_num_new | ( | VALUE | ,
|  | VALUE |
| ) |  |

Definition at line 2553 of file time.c.

## ◆ rb_time_succ()

VALUE rb_time_succ | ( | VALUE |  | ) |

Definition at line 4229 of file time.c.

## ◆ rb_time_timespec()

struct timespec rb_time_timespec | ( | VALUE | time | ) |

Definition at line 2692 of file time.c.

## ◆ rb_time_timespec_interval()

struct timespec rb_time_timespec_interval | ( | VALUE | num | ) |

Definition at line 2706 of file time.c.

## ◆ rb_time_timespec_new()

VALUE rb_time_timespec_new | ( | const struct timespec * | ts,
|  | int | offset
| ) |  |

Returns a time object with UTC/localtime/fixed offset.

offset is -86400 < fixoff < 86400 or INT_MAX (localtime) or INT_MAX-1 (utc)

Definition at line 2530 of file time.c.

## ◆ rb_time_timeval()

struct timeval rb_time_timeval | ( | VALUE | time | ) |

Definition at line 2675 of file time.c.

Referenced by rb_thread_sleep().

## ◆ rb_time_utc_offset()

VALUE rb_time_utc_offset | ( | VALUE | time | ) |

Definition at line 4791 of file time.c.

## ◆ rb_timespec_now()

void rb_timespec_now | ( | struct timespec * |  | ) |

Definition at line 1873 of file time.c.

## ◆ rb_undef()

void rb_undef | ( | VALUE | ,
|  | ID |
| ) |  |

Definition at line 1200 of file vm_method.c.

## ◆ rb_undef_alloc_func()

void rb_undef_alloc_func | ( | VALUE |  | ) |

Definition at line 722 of file vm_method.c.

Referenced by Init_Binding(), Init_ISeq(), Init_ossl_engine(), Init_Proc(), Init_VM(), and InitVM_Struct().

## ◆ rb_undefine_finalizer()

VALUE rb_undefine_finalizer | ( | VALUE |  | ) |

Definition at line 3191 of file gc.c.

## ◆ rb_update_max_fd()

void rb_update_max_fd | ( | int | fd | ) |

Definition at line 218 of file io.c.

Referenced by rb_file_load_ok(), and rsock_init_sock().

## ◆ rb_usascii_str_new()

VALUE rb_usascii_str_new | ( | const char * | ,
|  | long |
| ) |  |

Definition at line 780 of file string.c.

## ◆ rb_usascii_str_new_cstr()

VALUE rb_usascii_str_new_cstr | ( | const char * |  | ) |

Definition at line 820 of file string.c.

## ◆ rb_usascii_str_new_static()

VALUE rb_usascii_str_new_static | ( | const char * | ,
|  | long |
| ) |  |

Definition at line 878 of file string.c.

## ◆ rb_utf8_str_new()

VALUE rb_utf8_str_new | ( | const char * | ,
|  | long |
| ) |  |

Definition at line 788 of file string.c.

## ◆ rb_utf8_str_new_cstr()

VALUE rb_utf8_str_new_cstr | ( | const char * |  | ) |

Definition at line 828 of file string.c.

## ◆ rb_utf8_str_new_static()

VALUE rb_utf8_str_new_static | ( | const char * | ,
|  | long |
| ) |  |

Definition at line 884 of file string.c.

## ◆ rb_uv_to_utf8()

int rb_uv_to_utf8 | ( | char | [6],
|  | unsigned long |
| ) |  |

Definition at line 1651 of file pack.c.

## ◆ rb_vsprintf()

VALUE rb_vsprintf | ( | const char * | ,
|  | va_list |
| ) |  |

Definition at line 1191 of file sprintf.c.

Referenced by rb_frozen_error_raise(), rb_name_error(), rb_name_error_str(), and rb_vraise().

## ◆ rb_waitpid()

rb_pid_t rb_waitpid | ( | rb_pid_t | pid,
|  | int * | status,
|  | int | flags
| ) |  |

Definition at line 1213 of file process.c.

Referenced by rb_syswait().

## ◆ rb_write_error()

void rb_write_error | ( | const char * |  | ) |

Definition at line 7930 of file io.c.

## ◆ rb_write_error2()

void rb_write_error2 | ( | const char * | ,
|  | long |
| ) |  |

Definition at line 7911 of file io.c.

## ◆ ruby_default_signal()

void ruby_default_signal | ( | int |  | ) |

Definition at line 402 of file signal.c.

## ◆ ruby_signal_name()

const char* ruby_signal_name | ( | int |  | ) |

Definition at line 310 of file signal.c.

## Variable Documentation

## ◆ rb_argv0

RUBY_EXTERN VALUE rb_argv0

Definition at line 734 of file intern.h.

## ◆ rb_default_rs

RUBY_EXTERN VALUE rb_default_rs

Definition at line 586 of file intern.h.

## ◆ rb_fs

RUBY_EXTERN VALUE rb_fs

Definition at line 583 of file intern.h.

## ◆ rb_output_fs

RUBY_EXTERN VALUE rb_output_fs

Definition at line 584 of file intern.h.

## ◆ rb_output_rs

RUBY_EXTERN VALUE rb_output_rs

Definition at line 587 of file intern.h.

## ◆ rb_rs

RUBY_EXTERN VALUE rb_rs

Definition at line 585 of file intern.h.

## ◆ rb_str_setter

rb_gvar_setter_t rb_str_setter

Definition at line 828 of file intern.h.

RB_UNLIKELY
#define RB_UNLIKELY(x)
Definition: defines.h:92
rb_block_given_p
int rb_block_given_p(void)
Determines if the current method is given a block.
Definition: eval.c:897
RB_OBJ_FROZEN
#define RB_OBJ_FROZEN(x)
Definition: ruby.h:1342
ID2SYM
#define ID2SYM(x)
Definition: ruby.h:414
INTEGER_PACK_MSWORD_FIRST
#define INTEGER_PACK_MSWORD_FIRST
Definition: intern.h:151
obj
const VALUE VALUE obj
Definition: rb_mjit_min_header-2.7.0.h:5742
rb_enumeratorize_with_size
#define rb_enumeratorize_with_size(obj, id, argc, argv, size_fn)
Definition: intern.h:260
rb_frame_this_func
ID rb_frame_this_func(void)
The original name of the current method.
Definition: eval.c:1182
SIZED_ENUMERATOR
#define SIZED_ENUMERATOR(obj, argc, argv, size_fn)
Definition: intern.h:265
argv
char ** argv
Definition: ruby.c:223
rb_enumeratorize_with_size_kw
#define rb_enumeratorize_with_size_kw(obj, id, argc, argv, size_fn, kw_splat)
Definition: intern.h:262
argc
int argc
Definition: ruby.c:222
INTEGER_PACK_LSWORD_FIRST
#define INTEGER_PACK_LSWORD_FIRST
Definition: intern.h:152
SIZED_ENUMERATOR_KW
#define SIZED_ENUMERATOR_KW(obj, argc, argv, size_fn, kw_splat)
Definition: intern.h:268